;Системные ячейки монитора БК
;Системные признаки DMBK (SYSPR )
PRCW =          40      ; Признак цветного режима (формат 32)
PRINF =         41      ; Признак инверсии фона
PRRP =          42      ; Признак расширенной памяти
PRRUS =         43      ; Признак русского регистра
PRPODC =        44      ; Признак подчёркивания символа
PRINWS =        45      ; Признак инверсии символа
PRISU =         46      ; Признак индикации су
PRBLR =         47      ; Признак блокировки редактирования
PRGRAF =        50      ; Признак графического режима
PRZAP =         51      ; Признак режима записи
PRSTIR =        52      ; Признак режима стирания
PRCWSS =        53      ; Признак цветного режима в служебной строке(СС)
PRPSSS =        54      ; Признак подчёркивания символа в СС
PRISSS =        55      ; Признак инверсии символа в СС
PRGAHK =        56      ; Признак гашения курсора
;Переменные драйвера клавиатуры ( DLLAW )
BUFKL =         104     ; Буфер клавиатуры
PRZKB =         105     ; Признак записи кода в буфер
BKPOWT =        106     ; Буфер константы повтора (t паузы)
PRPOWT =        110     ; Признак повтора кода
SCTAB =         111     ; Счётчик табуляции
MTAB =          112     ; Маска табуляции
SCKLC =         122     ; Счётчик ключа
TAKLC =         124     ; Текущий адрес ключа
;Переменные драйвера ТВ-монитора ( DTWMN )
PRNRUL =        152     ; Признак нарушения рулона
PRZTCK =        153     ; Признак записи точки
MASPGT =        154     ; Маска позиции графической точки (ГТ)
NMPGT =         155     ; Начальная маска позиции ГТ
NOMSIM =        156     ; Номер символа на экране
AS =            160     ; Адрес символа
DSIMB =         162     ; Длина символа в байтах
KSVP =          164     ; Количество символов на экране
AGTVP =         166     ; Адрес (номер) ГТ на экране
AGT =           170     ; Адрес ГТ
DGW =           172     ; Длина графического вектора
SCTVS =         174     ; Счётчик ТВ-строк
BUFX =          176     ; Буфер координаты X
BUFY =          200     ; Буфер координаты Y
ANVP =          202     ; Адрес начала видеопамяти
BAZVP =         204     ; База видеопамяти
DVPB =          206     ; Длина видеопамяти в байтах
DGPB =          210     ; Длина графической памяти в байтах
FON =           212     ; Фон экрана
MASCW =         214     ; Маска цвета
FONSS =         216     ; Фон служебной строки (СС)
MSWSS =         220     ; Маска цвета СС
SCKOD =         222     ; Счётчик кодов
SCUIND =        224     ; Счётчик установки индикаторов
;Переменные драйвера магнитофона ( DMAG )
BPDMAG =        320     ; Блок параметров DMAG


;Переменные, буфера и константы
VERS   = 120004 ;Версия Системы 3.15
BLK    = 120006 ;Адрес блока параметров диска
SUBTEK = 120010 ;Номер подкаталога на тек. диске
SUBOLD = 120011 ;Подкаталог в другой панели
DEVTEK = 120012 ;Номер текущего устройства
SUBDIR = 120013 ;Подкаталог для CREATE, временн.
DIR    = 120014 ;Адрес буфера чтения каталога
TSTEP  = 120070 ;Задержка шага головки дисковода
PANEL  = 120072 ;Байты устройств в панелях "MC"
SCREEN = 120074 ;Ячейка перехвата вывода сообщений системы, адрес подпрограммы
                ;обращения вместо EMT16. Для запрета вывода - адрес ближайшей
                ;команды RTS PC
STEK   = 120076 ;Адрес стека перехватчика ЕМТ36
USER   = 120100 ;Значение 1  Адреса  и  значения
       ; 120102 ;Адрес 1     трех ячеек, восста-
       ; 120104 ;Значение 2  навливаемых  систе-
       ; 120106 ;Адрес 2     мой после  ЕМТ14  и
       ; 120110 ;Значение 3  перезапуска
       ; 120112 ;Адрес 3
USER2  = 120114 ;Адрес подпрограммы перед запуском "MC" или 0
NONDOS = 120116 ;Адрес подпрограммы имитации ЕМТ36 для не DOS дисков, или 0
                ;(вывод сообщения Non DOS Disk)
OVERWR = 120124 ;Признак AutoOwerwrite, 1-выкл.
PRED   = 120125 ;Признак Predelete, 1-выкл.
FLOP   = 120126 ;Дисковод:  0 - 40, 1 - 80 track
PALET  = 120127 ;Палитра БК11(М),оцветнение БК10
SY     = 120130 ;Диск загрузки системы (@:)
DK     = 120131 ;Привод для оверлеев (!:)
SORTIR = 120132 ;Режимы сортировки на панелях MC
LD0    = 120134 ;Смещение к логическому диску (в блоках), 0 - корень
LD1    = 120136 ;то же, но для текущей операции
LD2    = 120140 ;Смещение для другой панели MC
NAM    =    306 ;Адрес блока параметров EMT36
BLOK   =    314 ;Номер блока загруженного файла
SIZE   =    316 ;Кол-во блоков в файле
;Подпрограммы MK-DOS
INIDRV = 120016 ; Инициализация драйвера дисковода
EMT6   = 120020 ; Команда EMT6 с автоповтором (исп. Rename)
INOUT  = 120022 ; Чтение/запись блока (160004 исп.буфер ДОС)
RDDIR  = 120024 ; Чтение каталога в буфер (@#DIR)
DIRFIN = 120026 ; Поиск файла в каталоге
DIRPRI = 120030 ; Вывод каталога на экран
FRFIN  = 120032 ; Поиск свободного места в каталоге
CREAT  = 120034 ; Создание записи о файле в каталоге
DELETE = 120036 ; Удаление файла (с запросом или без него)
SAVDIR = 120042 ; Запись каталога
EMT20  = 120044 ; Полная имитация EMT20 с исп. ячейки SCREEN
PRINAM = 120046 ; Вывод имени с без пробелов в конце
TXT    = 120050 ; Перемещаемый вывод надписей
STROKA = 120052 ; Редактор строки (исп. Rename)
OCTOUT = 120056 ; Вывод восьмеричного числа
DECOUT = 120060 ; Вывод десятичного числа
TST    = 120062 ; Замена управляющих кодов в R0 на пробелы
TST2   = 120064 ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
ERROR  = 120066 ; Расшифровка текстом No ошибки дисковода
FRFIN2 = 120120 ; Поиск свободного места по длине в блоках
CREAT2 = 120122 ; Создание записи о файле по длине в блоках


RX_CSR = 177560 ;регистр состояния приёмника
RX_DAT = 177562 ;регистр данных приёмника
TX_CSR = 177564 ;регистр состояния передатчика
TX_DAT = 177566 ;регистр данных передатчика

RX_Buffer=30000 ;буфер приёма данных
IOBuffer=36000  ;какой-то буфер
;
; ╔═════════════════════════════════════════════════════════════════════════╗
; ║     This file is generated by The Interactive Disassembler (IDA)        ║
; ║     Copyright (c) 2006 by DataRescue sa/nv, <ida@datarescue.com>        ║
; ║ Licensed to: Kon v Palto                                                ║
; ╚═════════════════════════════════════════════════════════════════════════╝
;
; Input MD5   : 88518C368534EFC8D48A5DAAF1AD15EF

; ───────────────────────────────────────────────────────────────────────────
; File Name   : TM177
; Format      : Binary file
; Base Address: 0000h Range: 0200h - 289Eh Loaded length: 269Eh

; Processor:        K1801VM1
; Target assembler: BK Turbo8 Cross Assembler

; ═══════════════════════════════════════════════════════════════════════════

START$:         jmp     Prepare
; ───────────────────────────────────────────────────────────────────────────
word_1004:      .word 0
word_1006:      .word 52525
word_1010:      .word 0
word_1012:      .word 177777
AnsiOption:     .byte 377
byte_1015:      .byte 0
EchoOption:     .byte 0
CopyScrOption:  .byte 0
byte_1020:      .byte 0
AutoDLOption:   .byte 377
XonXofOption:   .byte 377
NewIRPSOption:  .byte 0
; ───────────────────────────────────────────────────────────────────────────

Process:        mov     #START$, SP
                mtps    #0
                clr     word_6642

loc_1040:       tstb    TX_CSR          ; что там с передатчиком?
                bpl     1$              ; пока данные не переданы - переходим
; ───────────────────────────────────────────────────────────────────────────
                .word /GetKeyAR+167366  ; проверяем ввод с клавиатуры
                bcs     1$              ;ничего не нажато, или нажато в первый раз
                bitb    #140, R0        ; что за код?
                bne     2$              ; букво-цифра, перейдём туда
                tstb    R0              ; больше >200
                bmi     2$              ; тоже туда
                tst     word_7702
                bne     2$
                bis     #4000, R0       ;обработаем полученный код
                mov     PC, R5
3$:             tst     (R5)
                beq     2$
                cmp     R0, (R5)+
                bne     3$
                jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────
                .word 4005      ; ГРАФ - по моему, фигня какая-то. странные какие-то коды
                comb    EchoOption
                br      1$
; ───────────────────────────────────────────────────────────────────────────
                .word 4001      ; ПОВТ
                comb    AnsiOption
                br      1$
; ───────────────────────────────────────────────────────────────────────────
                .word 4003      ; КТ
                comb    CopyScrOption
                br      1$
; ───────────────────────────────────────────────────────────────────────────
                .word 4004      ; БЛОК РЕД
                .word /DownloadFunc+167366
; ───────────────────────────────────────────────────────────────────────────
                .word 4025      ; СУ/У
                .word /UploadFunc+167366
; ───────────────────────────────────────────────────────────────────────────
                .word 0         ; конец цепочки

2$:             .word /S01626+167366    ; п/п 1626, 167366 = 156754 / 2
1$:             cmp     R4, RX_BuffPtr
                beq     loc_1040
                movb    (R4)+, R0
                bic     #4000, R4
                tstb    CopyScrOption
                beq     5$
                mov     #76000, @#177716
                movb    R0, @TX_LogBuffPtr
                inc     TX_LogBuffPtr
                tst     TX_LogBuffPtr
                bpl     4$
                trap    4
4$:             mov     #16000, @#177716

5$:             tstb    AutoDLOption
                beq     6$
                .word /CheckAutoDL+167366

6$:             tst     (PC)+
word_1246:      .word 0
                bne     7$
                tstb    AnsiOption
                beq     10$
                cmpb    #33, R0
                bne     10$
                clr     word_1310
                mov     R4, word_1246
                br      loc_1040

7$:             bitb    #140, R0
                beq     11$
                tst     (PC)+
word_1310:      .word 0
                bne     8$
                cmpb    #'[, R0
                bne     9$
                com     word_1310
                br      loc_1040

8$:             cmpb    #'/, R0
                bhis    9$
                cmpb    #'?, R0
                bhi     loc_1040
9$:             mov     word_1246, R4
                movb    #33, R0

10$:            call    sub_6734
                call    sub_2060

11$:            clr     word_1246
                call    KeyPressCheck
                bne     12$
                call    sub_6752
12$:            br      Process
; ───────────────────────────────────────────────────────────────────────────
; приём данных по прерыванию
VEC360:         mov     R0, -(SP)
                movb    RX_DAT, R0      ; читаем полученный байт
                tstb    XonXofOption       ; чтение по сигналу
                beq     1$              ; нет, сразу
                cmpb    #23, R0         ; приняли код 23?
                bne     2$              ; нет
                mov     (PC)+, (PC)+    ; что-то делаем
                .word -1
word_1432:      .word 0
                br      3$

2$:             cmpb    #21, R0         ; приняли код 21?
                bne     1$              ; нет
                clr     word_1432
                br      3$

1$:             movb    R0, @RX_BuffPtr ;помещаем данные в буфер
                inc     (PC)+
RX_BuffPtr:     .word   RX_Buffer
                bic     #4000, RX_BuffPtr       ; циклично
                inc     (PC)+
ReceiveCounter: .word 0
3$:             mov     (SP)+, R0
                rti

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


SendSTRING:     mov     R0, -(SP)       ; сохраняем R0
                mov     2(SP), R0       ; достанем адрес возврата из п/п
                mov     R1, 2(SP)       ; сохраняем R1 вместо адреса возврата
                mov     R0, R1          ; адрес текста

2$:             movb    (R1)+, R0       ; берём очередной байт
                beq     1$              ; 0 - конец
                call    SendCHAR        ; передаём
                br      2$              ; и т.д.

1$:             inc     R1              ; выравниваем адрес возврата
                bic     #1, R1
                mov     (SP)+, R0       ; восстанавливаем R0
                rts     R1              ; восстанавливаем R1 и выходим из п/п
; End of function SendSTRING


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


SendCHAR:       tstb    TX_CSR          ; смотрим состояние передатчика
                bpl     SendCHAR        ; пока буфер не пуст, подождём
                tstb    XonXofOption    ; запись по сигналу?
                beq     2$              ; нет, сразу

1$:             tst     word_1432       ; ждём сигнала
                bne     1$

2$:             movb    R0, TX_DAT      ; передаём данные
                inc     (PC)+
SendCounter:    .word 0
                tst     TX_LogBuffPtr   ; а это наверное лог переданных данных
                bmi     3$              ; выключен.
                mov     #36000, 177716  ; а если включен
                movb    R0, @TX_LogBuffPtr ; сохраним и туда
                inc     TX_LogBuffPtr
                mov     #16000, 177716
3$:             return
; End of function SendCHAR

; ───────────────────────────────────────────────────────────────────────────

S01626:         tstb    AnsiOption
                bne     4$

6$:             clr     word_7702
                bic     #177400, R0
                mov     R0, -(SP)
                movb    byte_13016(R0), R0
                .word /SendCHAR+167366
                mov     (SP)+, R0
                tstb    EchoOption
                beq     3$
                cmp     #37, R0
                bhis    1$
                jmp     sub_5404

1$:             cmpb    #12, R0
                bne     2$
                emt     16
                mov     #15, R0
                .word /SendCHAR+167366

2$:             emt     16
3$:             return

4$:             cmpb    #40, R0
                blos    6$
                tst     word_7702
                bne     6$
                bic     #177400, R0
                bis     #4000, R0
                mov     PC, R5

5$:             cmp     #EndChain_01626, R5
                beq     6$
                cmp     R0, (R5)+
                bne     5$
                jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────
                .word 4032      ;Стрелка вверх
                .word /SendSTRING+167366
                .asciz <33><133>"A"
                .even
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 4037      ;СУ/Ъ (стрелка влево-вниз)
                ;вот странно. тут код 37 делает Esc B
                ; а в другом месте Esc B делает код 33
                ;наверное тут ошибка.
                ;Тут нет ошибки. В драйвере клавиатуры код 33 подменяется на 37
                .word /SendSTRING+167366
                .asciz <33><133>"B"
                .even
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 4031      ;Стрелка вправо
                .word /SendSTRING+167366
                .asciz <33><133>"C"
                .even
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 4010      ;Стрелка влево
                .word /SendSTRING+167366
                .asciz <33><133>"D"
                .even
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 4014      ;СБР
                .word /SendSTRING+167366
                .asciz <33><133>"2J"
                .even
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 4022      ;СУ/R
                .word /SendSTRING+167366
                .asciz <33><133>"H"
                .even
                return
EndChain_01626:

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_2060:       cmpb    #33, R0         ; ESC код?
                beq     1$

3$:             bic     #177400, R0
                movb    byte_12416(R0), R0
                br      2$

1$:             tstb    AnsiOption
                beq     3$
                movb    (R4)+, R0
                bic     #4000, R4
                mov     R4, word_1246
                cmpb    #133, R0 ; '['
                beq     4$
                bis     #4000, R0
                mov     #BgnChain_2060, R5
6$:             tst     (R5)
                beq     5$
                cmp     R0, (R5)+
                bne     6$
                jmp     (R5)

4$:             movb    (R4)+, R0
                bic     #4000, R4
                cmpb    #72, R0 ; ':'
                blos    7$
                cmpb    #57, R0 ; '/'
                blo     4$
7$:             cmpb    #73, R0 ; ';'
                beq     4$
                movb    R0, R0
                mov     #EscCodes, R2   ; "n!hlABCDmHfusJK"
                mov     #EscCodeSubTbl, R5

8$:             tstb    (R2)
                beq     5$
                tst     (R5)+
                cmpb    R0, (R2)+
                bne     8$
                mov     word_1246, R4
                call    StrToDec
                jmp     @-(R5)

2$:             cmpb    #40, R0 ; ' '
                blos    9$
                emt     16
5$:             return

9$:             jmp     sub_5404
; End of function sub_2060

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode156: cmp     #5, R1          ; cmd n
                bne     1$
                call    SendSTRING
                .asciz <33><133>"0n"
                .even
2$:             return

1$:             cmp     #6, R1
                bne     2$
                call    SendSTRING
                .asciz <33><133>""
                .even
                emt     26
                inc     R1
                inc     R2
                mov     R2, R0
                call    Dec2ToStr
                call    SendSTRING
                .asciz ";"
                .even
                mov     R1, R0
                call    Dec2ToStr
                call    SendSTRING
                .asciz "R"
                .even
                return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode041: .word /SendSTRING+167366 ; cmd !
                .asciz <33><133>"!"
                .even
                return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode150: cmp     #24, R1         ; cmd h
                bne     1$
                mov     #-1, word_1010
1$:             return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode154: cmp     #24, R1         ; cmd l
                bne     1$
                clr     word_1010
1$:             return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode101: call    sub_3434        ; cmd A
                mov     #32, R0
loc_2426:       emt     16
                sob     R1, loc_2426
                return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode102: call    sub_3434        ; cmd B
                mov     #33, R0         ;вот тут. А выше был код 37
                br      loc_2426

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode103: call    sub_3434        ; cmd C
                mov     #31, R0
                br      loc_2426

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode104: call    sub_3434        ; cmd D
                mov     #10, R0
                br      loc_2426

; ───────────────────────────────────────────────────────────────────────────
loc_2472:       cmpb    #'m, R0
                bne     1$
                return

1$:             call    StrToDec

sub_EscCode155: mov     PC, R2          ; cmd m
2$:             cmp     #EndChain_Escm, R2
                beq     loc_2472
                cmp     (R2)+, R1
                bne     2$
                jmp     (R2)
; ───────────────────────────────────────────────────────────────────────────
                .word 0         ;код 0
                clrb    PRPODC
                mov     #52525, word_1006
loc_2540:       clr     word_1004
                clrb    PRINWS
                br      loc_2472
; ───────────────────────────────────────────────────────────────────────────
                .word 7         ;код 7
                comb    PRINWS
                br      loc_2472
; ───────────────────────────────────────────────────────────────────────────
                .word 36        ;код 36
3$:             clr     word_1006
                br      loc_2472
; ───────────────────────────────────────────────────────────────────────────
                .word 37        ;код 37
                br      3$
; ───────────────────────────────────────────────────────────────────────────
                .word 40        ;код 40 (пробел)
4$:             mov     #52525, word_1006
                br      loc_2472
; ───────────────────────────────────────────────────────────────────────────
                .word 42        ;код 42(")
                mov     #125252, word_1006
                br      loc_2472
; ───────────────────────────────────────────────────────────────────────────
                .word 45        ;код 45 (%)
                br      4$
; ───────────────────────────────────────────────────────────────────────────
                .word 50        ;код 50 (()
                br      loc_2540
; ───────────────────────────────────────────────────────────────────────────
                .word 51        ;код 51 ())
5$:             mov     #-1, word_1004
                br      loc_2472
; ───────────────────────────────────────────────────────────────────────────
                .word 52        ;код 52 (*)
                mov     #52525, word_1004
                br      loc_2472
; ───────────────────────────────────────────────────────────────────────────
                .word 54        ;код (,)
                mov     #125252, word_1004
                br      loc_2472
; ───────────────────────────────────────────────────────────────────────────
                .word 57        ;код (/)
                br      5$
EndChain_Escm:

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode110_146:
                mov     R1, -(SP)       ; cmd H,f
                cmpb    #';, R0
                beq     1$
                clr     R1
                br      2$

1$:             call    StrToDec
                dec     R1

2$:             tst     (SP)
                beq     3$
                dec     (SP)

3$:             mov     (SP)+, R2
                emt     24
                return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode165: mov     word_2772, R2   ; cmd u
1$:             mov     word_2766, R1
                emt     24
                cmp     AS, word_3000
                beq     2$
                dec     R2
                br      1$

2$:             return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode163: emt     26              ; cmd s
                mov     R1, (PC)+
word_2766:      .word 0
                mov     R2, (PC)+
word_2772:      .word 0
                mov     AS, (PC)+
word_3000:      .word 0
                return

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode112: cmp     #2, R1          ; cmd J
                bne     1$
                mov     #14, R0
                emt     16
6$:             return

1$:             tst     R1
                bne     2$
                emt     26
                mov     R1, -(SP)
                mov     R2, -(SP)
                mov     #27, R1
                sub     (SP), R1
                beq     3$

5$:             inc     R1
4$:             call    sub_3444
                inc     R2
                sob     R1, 4$
3$:             mov     (SP)+, R2
                mov     (SP)+, R1
                emt     24
                return

2$:             cmp     #1, R1
                bne     6$
                emt     26
                mov     R1, -(SP)
                mov     R2, -(SP)
                clr     R2
                emt     24
                mov     (SP), R1
                beq     3$
                br      5$

; ───────────────────────────────────────────────────────────────────────────
sub_EscCode113: cmp     #2, R1          ; cmd K
                bne     1$
                emt     26
                mov     R2, -(SP)
                mov     R1, -(SP)

3$:             call    sub_3444
4$:             mov     (SP)+, R1
                mov     (SP)+, R2
                emt     24
6$:             return

1$:             tst     R1
                bne     2$
                emt     26
                mov     R2, -(SP)
                mov     R1, -(SP)
                beq     3$
                mov     #117, R1 ; 'O'
                sub     (SP), R1
                beq     4$
                
7$:             inc     R1
                mov     #40, R0 ; ' '
                comb    byte_1015
5$:             call    sub_5404
                sob     R1, 5$
                clrb    byte_1015
                br      4$

2$:             cmp     #1, R1
                bne     6$
                emt     26
                mov     R2, -(SP)
                mov     R1, -(SP)
                beq     4$
                clr     CRDX80          ; Своя координата курсора Х
                br      7$

; ───────────────────────────────────────────────────────────────────────────
BgnChain_2060:  .word 4104      ;код D
                .word /MKD$TXT+167366
                .asciz  <33>
                .even
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 4105      ;код E
                .word /MKD$TXT+167366
                .asciz <12><15>
                .even
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 4115      ;код M
                .word /MKD$TXT+167366
                .asciz  <32>
                .even
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 0         ; конец цепочки

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

;преобразование строки в десятичное число.
;вход: данные в буфере приёма
;выход: R1 - число
StrToDec:       clr     R1              ;аккумулятор
1$:             clr     R0              ;бессмысленная команда, если за ней не bisb
                movb    (R4)+, R0       ;берём код из буфера
                bic     #4000, R4       ;корректируем указатель
                cmpb    #73, R0 ; ';'   ;если код >= 73 (почему? а двоеточие (72)?)
                blos    2$              ;выходим
                cmpb    #57, R0 ; '/'   ;если код <= 57
                bhis    2$              ;выходим.
                call    sub_3334        ;если цифра или двоеточие, обработаем
                br      1$              ;и повторим

2$:             return
; End of function StrToDec


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_3334:       sub     #'0, R0         ;вычитаем 0, получаем число от 0 до 10.
                bmi     1$              ;ещё раз убедимся, что на входе были корректные данные
                cmp     #10., R0        ;если результат >=10.
                blos    1$              ;выходим. вот тут отсекаем попадающее сюда двоеточие
                asl     R1              ;умножаем на 10.
                mov     R1, -(SP)
                asl     R1
                asl     R1
                add     (SP)+, R1
                add     R0, R1          ;прибавляем мл. разряд к результату.
1$:             return
; End of function sub_3334


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;преобразование  двузначного десятичного числа в строку
;вход: R0 - число
;выход: строка, отправленная по ИРПС
;если число больше 99. то алгоритм будет работать неправильно
Dec2ToStr:      clr     R5
                mov     #10., R3        ;база счисления
                cmp     R0, R3          ;если число < 10
                blo     sub_3424        ;просто выведем его

2$:             sub     R3, R0          ;вычитаем базу
                bmi     1$              ;пока возможно
                inc     R5              ;считаем порядок
                br      2$

1$:             add     R3, R0          ;прибавляем назад
                mov     R0, -(SP)
                mov     R5, R0          ;и выводим полученный порядок
                call    sub_3424
                mov     (SP)+, R0       ;и второе число выведем.

sub_3424:       add     #60, R0
                jmp     SendCHAR
; End of function Dec2ToStr


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; корректируем R1, если там 0, то меняем на 1
sub_3434:       tst     R1
                bne     1$
                inc     R1
1$:             return
; End of function sub_3434


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;берём какой-то байт и зарисовываем им строку на экране

sub_3444:       mov     R1, -(SP)
                clr     R1
                emt     24
                mov     AS, R5
                mov     #5, R1
                mov     word_1004, R0

1$:             mov     #74, R3
2$:             movb    R0, (R5)+
                movb    R0, 77(R5)
                sob     R3, 2$
                add     #104, R5
                bpl     3$
                sub     #40000, R5
3$:             sob     R1, 1$
                mov     (SP)+, R1
                return
; End of function sub_3444

; ───────────────────────────────────────────────────────────────────────────
VEC04:          jsr     R5, PUSHAR
                .word /sub_EscCode163+167366    ; cmd s
                mov     #V04.2, 4
                .word /S04564+167366
                .word 40056
                .word 21
                .word 170
                .word /S05220+167366
                .word MainMenu
                .word 1200
; ───────────────────────────────────────────────────────────────────────────

loc_3554:       tstb    EchoOption
                bne     1$
                trap    0
                br      2$

1$:             trap    1
2$:             tstb    AnsiOption
                bne     3$
                trap    2
                br      4$

3$:             trap    3
4$:             tstb    AutoDLOption
                bne     5$
                trap    36
                br      6$

5$:             trap    35
6$:             tstb    CopyScrOption
                bne     7$
                trap    40
                br      8$

7$:             trap    37
8$:             tstb    XonXofOption
                bne     9$
                trap    56
                br      10$

9$:             trap    55
10$:            tstb    NewIRPSOption
                bne     11$
                trap    60
                br      12$

11$:            trap    57
12$:            .word /S04512+167366
                emt     264             ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
                movb    R0, R0
                bis     #4000, R0
                mov     PC, R5
13$:            tst     (R5)
                beq     12$
                cmp     R0, (R5)+
                bne     13$
                jmp     (R5)
; ───────────────────────────────────────────────────────────────────────────
                .word 4124              ; T
                br      14$
; ───────────────────────────────────────────────────────────────────────────
                .word 4105              ; E
                comb    EchoOption
                br      loc_3554
; ───────────────────────────────────────────────────────────────────────────
                .word 4101              ; A
                comb    AnsiOption
                br      2$
; ───────────────────────────────────────────────────────────────────────────
                .word 4114              ; L
                comb    AutoDLOption
                br      4$
; ───────────────────────────────────────────────────────────────────────────
                .word 4103              ; C
                comb    CopyScrOption
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4130              ; X
                comb    XonXofOption
                br      8$
; ───────────────────────────────────────────────────────────────────────────
                .word 4116              ; N
                comb    NewIRPSOption
                br      10$
; ───────────────────────────────────────────────────────────────────────────
                .word 4104              ; D
                jsr     R5, POPAR
                .word /CloseOpenWindow+167366
                .word /DownloadFunc+167366
; ───────────────────────────────────────────────────────────────────────────
                .word 4125              ; U
                jsr     R5, POPAR
                .word /CloseOpenWindow+167366
                .word /UploadFunc+167366
; ───────────────────────────────────────────────────────────────────────────
                .word 4012              ; <12>
                br      14$
; ───────────────────────────────────────────────────────────────────────────
                .word 4033              ; <33>
14$:            .word /CloseOpenWindow+167366
                jsr     R5, POPAR
                mov     #VEC04, 4
                .word /Process+167366
; ───────────────────────────────────────────────────────────────────────────
                .word 4121              ; Q
V04.2:          .word /OnQuit+167366    ; Восстановление векторов перед выходом
; ───────────────────────────────────────────────────────────────────────────
                halt                    ;выход. и заодно, конец цепочки.

; ───────────────────────────────────────────────────────────────────────────
CloseOpenWindow:.word /S05106+167366
                .word /sub_EscCode165+167366    ; cmd u
                return
; ───────────────────────────────────────────────────────────────────────────

S04062:         cmp     R4, RX_BuffPtr
                beq     S04062
                clr     R0
                bisb    (R4)+, R0
                bic     #4000, R4
                tst     TX_LogBuffPtr
                bmi     1$
                mov     #36000, 177716
                movb    R0, @TX_LogBuffPtr
                inc     TX_LogBuffPtr
                mov     #16000, 177716
1$:             return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


S04134:         mov     R0, -(SP)
                mov     R1, -(SP)
                mov     R2, -(SP)
                mov     R3, -(SP)
                mov     R5, -(SP)
                mov     word_4250, R3
                mov     #1, R5
                mov     #177400, R2
                br      4206$
; End of function S04134


; ███████████████ S U B R O U T I N E ███████████████████████████████████████


S04164:         mov     R0, -(SP)
                mov     R1, -(SP)
                mov     R2, -(SP)
                mov     R3, -(SP)
                mov     R5, -(SP)
                clr     R3
                mov     #177400, R2
1$:             movb    (R1)+, R0
4206$:          swab    R3
                xor     R3, R0
                bic     R2, R0
                asl     R0
                mov     word_13420(R0), R0
                clrb    R3
                xor     R0, R3
                sob     R5, 1$
                mov     R3, word_4250
                mov     (SP)+, R5
                mov     (SP)+, R3
                mov     (SP)+, R2
                mov     (SP)+, R1
                mov     (SP)+, R0
                return
word_4250:      .word 0
; End of function S04164

; ───────────────────────────────────────────────────────────────────────────
S04252:         .word /S04330+167366
                bcs     2$
                cmpb    #21, R0
                beq     S04252
                cmpb    #23, R0
                beq     S04252
                cmpb    #15, R0
                beq     1$
                cmpb    #12, R0
                beq     1$
                cmpb    #30, R0
                beq     1$
                bitb    #140, R0
                beq     S04252
1$:             tst     (PC)+
2$:             sec
                return

; ───────────────────────────────────────────────────────────────────────────
S04330:         .word /S04336+167366
                .word 12
                return

; ───────────────────────────────────────────────────────────────────────────
S04336:         mov     (SP), R0
                mov     (R0)+, word_6636
                mov     R0, (SP)
1$:             cmp     RX_BuffPtr, R4
                bne     2$
                tst     word_6636
                bne     1$
                mov     #-1, R0
                br      3$

2$:             .word /S04062+167366
                tst     (PC)+
3$:             sec
                return
; ───────────────────────────────────────────────────────────────────────────
; обёртка для мкдосовской п/п TXT - Перемещаемый вывод надписей
; для вызова её через Call, вместо стандартного
; Вызов: JSR    R1,@TXT
;        .ASCIZ /СООБЩЕНИЕ/
;        .EVEN
;
; Зачем? Непонятно.
MKD$TXT:        mov     R1, -(SP)
                mov     2(SP), R1       ; достаём адрес возврата
                mov     (SP)+, (SP)     ; сохранённый R1 вместо адреса возврата
                jmp     @TXT            ; п/п МКДОС перемещаемый вывод надписей

; ───────────────────────────────────────────────────────────────────────────
;4414 подпрограмма, которая никогда не вызывается и нигде не используется
;что-то инвертирует на экране. похоже на курсор в меню.
                mov     word_10166, R0
                mov     word_10172, R1
1$:             dec     R1
                bmi     2$
                add     #1200, R0
                br      1$

                mov     word_10166, R0
                add     BAZVP, R0
                bpl     2$
                sub     #40000, R0
2$:             mov     #12, R2
3$:             mov     word_10170, R1
4$:             comb    (R0)+
                sob     R1, 4$
                add     #100, R0
                bpl     5$
                sub     #40000, R0
5$:             sub     word_10170, R0
                sob     R2, 3$
                return

; ───────────────────────────────────────────────────────────────────────────
;получение нового кода клавиши с автоповтором и ожиданием нажатия клавиши.
S04512:         .word /GetKeyAR+167366
                bcs     S04512
                return

; ───────────────────────────────────────────────────────────────────────────
;получение нового кода клавиши с автоповтором.
; выход: C если клавиша не нажата или нажата в первый раз
GetKeyAR:       tstb    PRZKB           ;новый код в буфер клавиатуры поступил?
                beq     1$              ;нет
                mov     #2000, GetFirstKeyDelay ;да - инициализируем задержку
                br      2$              ;и идём получать код клавиши

1$:             .word /KeyPressCheck+167366 ;проверим, клавиша нажата?
loc_4540:       bne     3$              ; нет
                dec     (PC)+           ; а если нажата, считаем задержку
GetFirstKeyDelay:.word 2000             ; если очень долго держать клавишу нажатой,
                                        ; тут произойдёт переполнение и снова будет
                                        ; считаться, что клавиша нажата впервые,
                                        ; но значение задержки уже будет 77777
                bpl     3$              ; ещё не пора
                .word /AutoRepeatDelay+167366   ;пора - сделаем ещё задержку автоповтора
2$:             call    101122          ; получение нового кода клавиши, через драйвер клавиатуры
                tst     (PC)+
3$:             sec
                return

; ───────────────────────────────────────────────────────────────────────────
; рамку что ли какую-то рисуем
S04564:         jsr     R5, PUSHAR
                mov     14(SP), R4
                mov     (R4)+, R5       ;берём первый аргумент
                add     BAZVP, R5
                bpl     1$
                sub     #40000, R5
1$:             mov     R5, (PC)+       ;это будет адрес экрана
WndAddr:        .word 0
                mov     (R4)+, R1       ;берём второй аргумент, это ширина
                mov     R1, (PC)+
WndWidth:      .word 0
                mov     (R4)+, R2       ;берём третий аргумент, это высота
                mov     R2, (PC)+
WndHeight:      .word 0
                mov     R4, 14(SP)
                mov     (PC)+, R4
off_4636:       .word FreeSpace
                .word /S05204+167366    ;корректируем входные параметры и задаём R3
                mov     R1, R0
                br      1$

2$:             inc     R4
1$:             movb    (R5)+, (R4)+    ;копируем из экрана в буферную область
                clrb    (R4)
                br      5$

3$:             mov     R1, R0
4$:             cmpb    (R5), -1(R4)    ;сложно как-то копируем
                bne     2$
                cmpb    #376, (R4) ; '■'
                blos    2$
                inc     R5
5$:             incb    (R4)
                sob     R0, 4$
                .word /S05072+167366    ;сдвигаем адрес экрана на строку вниз.
                sob     R2, 3$

                mov     WndHeight, R2
                mov     WndAddr, R5     ;адрес экрана
                dec     R1
6$:             mov     R1, R0
7$:             mov     R5, R4
                add     #601, R4
                bpl     8$
                sub     #40000, R4
8$:             clrb    (R4)            ;теперь каким-то сложным способом
                clrb    (R5)+           ;очищаем то, что скопировали в буфер
                sob     R0, 7$
                .word /S05072+167366    ;сдвигаем адрес экрана на строку вниз.
                sob     R2, 6$

                mov     WndAddr, R5     ;адрес экрана
                .word /S05062+167366    ;инвертируем одну строку экрана
                .word /S05072+167366    ;сдвигаем адрес экрана на строку вниз.
                mov     #17, R2
                mov     #360, R4
                .word /S05050+167366    ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
                .word /S05062+167366    ;инвертируем одну строку экрана
                sub     R1, R5
                mov     #317, R2
                mov     #363, R4
                .word /S05050+167366    ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз

                mov     WndHeight, R0
                sub     #6, R0
9$:             .word /S05050+167366    ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
                sob     R0, 9$

                .word /S05062+167366    ;инвертируем одну строку экрана
                sub     R1, R5
                .word /S05050+167366    ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
                mov     #17, R2
                mov     #360, R4
                .word /S05050+167366    ;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
                .word /S05062+167366    ;инвертируем одну строку экрана
                br      loc_5176

; ───────────────────────────────────────────────────────────────────────────
;рисуем границы, левую R2 и правую R4, и двигаем адрес экрана на строку вниз
S05050:         movb    R2, (R5)
                add     R1, R5
                movb    R4, -1(R5)
                br      S05072

; ───────────────────────────────────────────────────────────────────────────
;инвертируем одну строку экрана
S05062:         mov     R1, R0
1$:             comb    (R5)+
                sob     R0, 1$
                return

; ───────────────────────────────────────────────────────────────────────────
;сдвигаем адрес экрана на строку вниз.
S05072:         add     R3, R5
                bpl     1$
                sub     #40000, R5
1$:             sub     R1, R5
                return

; ───────────────────────────────────────────────────────────────────────────
;а это наоборот, восстанавливаем содержимое экрана
S05106:         jsr     R5, PUSHAR
                mov     WndAddr, R5
                mov     WndWidth, R1
                mov     WndHeight, R2
                mov     off_4636, R4
                .word /S05204+167366    ;корректируем входные параметры и задаём R3
                mov     R1, R0
                inc     R0
                br      3$

1$:             mov     R1, R0
2$:             movb    R3, (R5)+
                decb    (R4)
                bne     4$
                inc     R4
3$:             movb    (R4)+, R3
4$:             sob     R0, 2$
                add     #100, R5
                bpl     5$
                sub     #40000, R5
5$:             sub     R1, R5
                sob     R2, 1$
loc_5176:       jsr     R5, POPAR
                return

; ───────────────────────────────────────────────────────────────────────────
;корректируем входные параметры и задаём R3
S05204:         inc     R1
                add     #6, R2
                mov     #100, R3
                return

; ───────────────────────────────────────────────────────────────────────────
;вывод текста в то место, где рисовали рамку
S05220:         mov     #AS, R3
                mov     (SP), R2
                mov     (R2)+, R1       ; берём первый аргумент, адрес текста
                mov     WndAddr, (R3)
                add     (R2)+, (R3)     ; берём второй аргумент, смещение от адреса экрана рамки
                bpl     1$
                sub     #40000, (R3)
1$:             mov     R2, (SP)
                add     #2, (R3)
                br      3$

2$:             add     #1200, (R3)
                bpl     3$
                sub     #40000, (R3)
3$:             clr     R2
4$:             movb    (R1)+, R0
                beq     6$
                cmpb    #12, R0
                bne     5$
                sub     R2, (R3)
                br      2$

5$:             emt     16
                bitb    #140, R0
                beq     4$
                inc     R2
                br      4$

6$:             return

; ───────────────────────────────────────────────────────────────────────────
;5324 функция нигде не используется и никогда не вызывается
;заполняем экран фоном
FillScr:        mov     #40000, R5
                mov     #200, R4
1$:             mov     #10421, R0
                mov     #40, R1
2$:             mov     R0, (R5)+
                sob     R1, 2$
                mov     #42104, R0
                mov     #40, R1
3$:             mov     R0, (R5)+
                sob     R1, 3$
                sob     R4, 1$
                return

; ───────────────────────────────────────────────────────────────────────────
;очистка экрана
ClrScr:         mov     #40000, R5
1$:             clr     (R5)+
                tst     R5
                bpl     1$
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;вывод символа в режиме 80 симв.в строке
sub_5404:       mov     R0, -(SP)
                mov     R1, -(SP)
                mov     R2, -(SP)
                mov     R3, -(SP)
                mov     R4, -(SP)
                mov     R5, -(SP)
                com     177660          ; запретим прерывания от клавиатуры
                bic     #177400, R0
                mov     #111576, R2     ;адрес стандартного шрифта
                aslb    R0              ;умножаем на 2
                bcc     2$              ;если код был < 200, пойдём обрабатывать
                cmp     #100, R0        ;если код был > 240,
                blo     1$              ;тоже пойдём обрабатывать
                mov     #byte_11704, R2 ;для кодов 200..240 будет своя матрица символов
                br      2$

1$:             add     #300, R0        ;коды 241..377
2$:             add     R0, R2          ;умножаем на 10.
                asl     R0
                asl     R0
                add     R2, R0
                mov     #10., R2
                mov     (PC)+, R4       ;странно, что этот кусок не вызывается как подпрограмма sub_5730
CRDX80:         .word 0                 ; Своя координата курсора Х
                movb    byte_14510(R4), R3      ; номер байта в строке для 80 симв. в строке
                movb    byte_14634(R4), R4      ; адрес маски отсечения для 80 символов в строке
                mov     word_14760(R4), R5      ; маска отсечения для 80 символов в строке
                asl     R4      ;это не только адрес маски оказывается
                add     AS, R3
3$:             movb    (R0), R1
                tst     word_1012
                bne     4$
                asr     R1
                bisb    (R0), R1
                bicb    word_1006, R1
4$:             inc     R0
                mov     R0, -(SP)
                mov     word_1004, R0
                beq     5$
                bis     word_1012, R0
                xor     R0, R1
5$:             mov     (SP)+, R0
                tstb    PRINWS
                beq     6$
                comb    R1
6$:             bic     #177700, R1
                add     R4, PC          ;это не только адрес маски оказывается, а ещё и смещение
                asl     R1
                asl     R1              ;R4==1
                asl     R1
                asl     R1              ;R4==3
                asl     R1
                asl     R1              ;R4==5
                asl     R1
                bicb    R5, (R3)        ;R4==7
                bisb    R1, (R3)+
                swab    R1
                swab    R5
                bicb    R5, (R3)
                bisb    R1, (R3)
                swab    R5
                add     #77, R3
                bpl     7$
                sub     #40000, R3
7$:             sob     R2, 3$

                inc     CRDX80          ; Своя координата курсора Х
                tstb    byte_1015
                bne     8$
                emt     26
                cmp     #80., R1
                bhi     8$
                clr     CRDX80          ; Своя координата курсора Х
                mov     #12, R0
                emt     16
8$:             mov     (SP)+, R5
                mov     (SP)+, R4
                mov     (SP)+, R3
                mov     (SP)+, R2
                mov     (SP)+, R1
                mov     (SP)+, R0
                clr     177660          ;обратно разрешим прерывания
                return
; End of function sub_5404


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_5730:       mov     CRDX80, R4              ; Своя координата курсора Х
                movb    byte_14510(R4), R3      ; номер байта в строке для 80 симв. в строке
                movb    byte_14634(R4), R4      ; адрес маски отсечения для 80 символов в строке
                mov     word_14760(R4), R5      ; маска отсечения для 80 символов в строке
                asl     R4
                add     AS, R3
                return
; End of function sub_5730


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Сохраняем в стеке все регистры
PUSHAR:         mov     R4, -(SP)
                mov     R3, -(SP)
                mov     R2, -(SP)
                mov     R1, -(SP)
                mov     R0, -(SP)
                mov     R5, -(SP)
                rts     R5
; End of function PUSHAR


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; Восстанавливаем из стека все регистры
POPAR:          mov     (SP)+, R0
                mov     (SP)+, R0
                mov     (SP)+, R1
                mov     (SP)+, R2
                mov     (SP)+, R3
                mov     (SP)+, R4
                rts     R5
; End of function POPAR

; ───────────────────────────────────────────────────────────────────────────
;6014 функция нигде не используется и никогда не вызывается
;кажись это функция редактирования строки.
                mov     R5, -(SP)
                mov     #AS, R5
                mov     R2, R4
                mov     R2, R3

1$:             tstb    (R3)+
                bne     3$
                dec     R3
2$:             movb    #40, (R3)+
                sob     R0, 2$
                br      4$

3$:             sob     R0, 1$
4$:             clrb    (R3)
                br      8$

10$:            mov     (R5), word_10202
                .word /S06640+167366
                emt     220             ; Команда EMT6 с автоповтором (исп. Rename)
                bit     #140, R0
                beq     5$
                tstb    (R2)
                beq     10$
                mov     R0, -(SP)
                call    sub_6234
                mov     (SP)+, R0
                movb    R0, (R2)+
                iot
                br      10$

5$:             bis     #4000, R0
                mov     PC, R1
6$:             tst     (R1)
                beq     10$
                cmp     R0, (R1)+
                bne     6$
                jmp     (R1)

; ───────────────────────────────────────────────────────────────────────────
                .word 4010      ;стрелка влево
                cmp     R2, R4
                beq     10$
                dec     R2
                dec     (R5)
                br      10$
; ───────────────────────────────────────────────────────────────────────────
                .word 4031      ;стрелка вправо
                tstb    (R2)
                beq     10$
                inc     R2
                inc     (R5)
                br      10$
; ───────────────────────────────────────────────────────────────────────────
                .word 4030      ;забой
                cmp     R2, R4
                beq     10$
                dec     (R5)
                dec     R2
                mov     R2, R1
7$:             movb    1(R1), (R1)+
                bne     7$
                movb    #40, -(R1)
8$:             .word /S06262+167366
                br      10$

; ───────────────────────────────────────────────────────────────────────────
                .word 4003      ;КТ
                br      9$
; ───────────────────────────────────────────────────────────────────────────
                .word 4012      ;Ввод
                tst     (PC)+
9$:             sec
                mov     (SP)+, R5
                return
; ───────────────────────────────────────────────────────────────────────────
                .word 0         ; конец цепочки

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
; функция используется только в функции редактирования строки,
; которая нигде не используется
sub_6234:       tstb    (R2)
                beq     7$
                mov     R2, R1
1$:             tstb    (R1)+
                bne     1$
                tst     -(R1)
                br      3$

2$:             movb    -(R1), 1(R1)
3$:             cmp     R1, R2
                bgt     2$

S06262:         mov     R2, R1
4$:             movb    (R1)+, R0
                beq     5$
                iot
                br      4$

5$:             sub     R2, R1
                dec     R1
                ble     7$
6$:             dec     (R5)
                sob     R1, 6$
7$:             return
; End of function sub_6234

; ───────────────────────────────────────────────────────────────────────────
; опять чтоль преобразование десятичного числа в строку.
; и вывод его на экран и в буфер
;теперь уже 32х разрядного
;вход:  R1 - адрес числа
;       R0 - адрес буфера, куда строку формировать. если 0,
;       то не надо в буфер, а просто вывести на экран.
S06310:         jsr     R5, PUSHAR
                mov     R0, word_6400
                mov     #10., R4
                mov     (R1)+, R0
                mov     (R1), R1
                clr     R2
1$:             clr     R3
                clr     R5

2$:             sub     R4, R0
                bcc     3$
                sbc     R1
                bmi     4$
3$:             inc     R3
                bne     2$
                inc     R5
                br      2$

4$:             add     R4, R0
                add     #'0, R0
                inc     R2
                movb    R0, -(SP)
                mov     R5, R1
                mov     R3, R0
                bne     1$
                mov     (PC)+, R1
word_6400:      .word 0
5$:             movb    (SP)+, R0
                tst     R1
                beq     6$
                movb    R0, (R1)+
6$:             iot
                sob     R2, 5$
                clrb    (R1)
                jmp     loc_5176

; ───────────────────────────────────────────────────────────────────────────
;6424 никогда и нигде не используется.
                clr     BUFKL
                emt     220             ; Команда EMT6 с автоповтором (исп. Rename)
                emt     264             ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
                cmpb    #12, R0
                bne     1$
                tst     (PC)+
1$:             sec
                return

; ───────────────────────────────────────────────────────────────────────────
AutoRepeatDelay:
                mov     R0, -(SP)
                mov     #5000, R0
                sob     R0, .
                mov     (SP)+, R0
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


KeyPressCheck:  call    DriveOff
                bit     #100, 177716
                return
; End of function KeyPressCheck

; ───────────────────────────────────────────────────────────────────────────
;loc_6500: ;подпрограмма никогда не вызывается и нигде не используется
1$:             call    DriveOff
                bit     #100, 177716
                beq     1$
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

;прекращаем дисководную активность
DriveOff:       clr     177130
                clr     @BLK            ; Адрес блока параметров диска
                return
; End of function DriveOff

; ───────────────────────────────────────────────────────────────────────────
; Восстановление векторов перед выходом
OnQuit:         mov     V30BUF, 30
                clr     120074
                mov     #100000, 4
                mov     #40000, 177662
                clr     176560
                return

; ───────────────────────────────────────────────────────────────────────────
VEC100:         mov     R0, -(SP)
                mov     #word_6632, R0
                dec     (R0)
                bpl     1$
                mov     #61, (R0)+
                inc     (R0)+
                dec     (R0)
1$:             dec     (PC)+
word_6610:      .word 23
                bpl     2$
                mov     #23, word_6610
                call    S06640
2$:             mov     (SP)+, R0
                rti
; ───────────────────────────────────────────────────────────────────────────
word_6632:      .word 61
word_6634:      .word 0
word_6636:      .word 0

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

S06640:         tst     (PC)+
word_6642:      .word 0
                bne     locret_6750

loc_6646:       com     (PC)+
word_6650:      .word 0

                jsr     R5, PUSHAR
                call    sub_5730
                mov     #2, R2
                add     #700, R3
                call    111434          ; подготовка для вывода строки ИЗ МАТРИЦЫ СИМВОЛА

1$:             movb    (R3), R0
                xor     R5, R0
                movb    R0, (R3)
                swab    R5
                movb    1(R3), R0
                xor     R5, R0
                swab    R5
                movb    R0, 1(R3)
                call    111434          ; подготовка для вывода строки ИЗ МАТРИЦЫ СИМВОЛА
                sob     R2, 1$
                jmp     loc_5176

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_6734:       mov     #-1, word_6642
                tst     word_6650
                bne     loc_6646
locret_6750:    return
; End of function sub_6734


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_6752:
                clr     word_6642
                tst     word_6650
                beq     S06640
                return
; End of function sub_6752

; ───────────────────────────────────────────────────────────────────────────
VEC10:          mov     R5, -(SP)
                mov     2(SP), R5
                mov     -(R5), R5       ; Получим код, вызвавший прерывание по вектору 10
                asl     R5
                sub     #156754, R5     ;волшебное число
loc_7004:       mov     2(SP), 4(SP)    ; адрес возврата из прерывания на место PS
                mov     (SP)+, (SP)     ; содержимое R5 на место PC
                rts     R5              ; Восстанавливаем R5 и переходим выполнять п/п МКДОС

; Перехватчик некоторых ЕМТ и выполнитель п/п МКДОС ЕМТ.
; EMT 216 - п/п по адресу 120016 Инициализация драйвера дисковода
; EMT 220 - п/п по адресу 120020
; и т.д.
VEC30:          mov     R5, -(SP)
                mov     2(SP), R5
                mov     -(R5), R5       ; Получим код команды EMT
                cmp     #104016, R5     ; перехватываем некоторые ЕМТы
                beq     E16H$
                cmp     #104020, R5
                beq     E20H$
                cmp     #104024, R5
                beq     E24H$
                cmp     #104026, R5
                beq     E26H$
                tstb    R5              ; остальные стандартные ЕМТы - пропускаем
                bpl     loc_7076        ; ЕМТ 200 и более - обработаем сами
                sub     #104200-120000, R5 ; Получим адрес, начиная с 120000
                mtps    4(SP)           ; бессмысленно портим PS в стеке
                mov     (R5), R5        ; выберем адрес подпрограммы МКДОС
                br      loc_7004

loc_7076:       mov     (SP)+, R5
                jmp     @(PC)+
V30BUF:         .word 0
; ───────────────────────────────────────────────────────────────────────────
; Перехватчик ЕМТ 20
E20H$:          movb    (R1)+, R0
                beq     loc_7376
                cmpb    #11, R0         ; коды 1..11 - количество пробелов
                blo     1$              ; Остальное - как обычно
                movb    R0, R2
                mov     #40, R0
2$:             iot
                sob     R2, 2$
                br      E20H$

1$:             emt     16
                br      E20H$
; ───────────────────────────────────────────────────────────────────────────
; Перехватчик ЕМТ 16
E16H$:          call    sub_6734
                bit     #140, R0        ; если коды 0..37, 200..237
                beq     1$              ; пойдём обработаем
                iot                     ; иначе - выведем
                br      loc_7376

1$:             mov     R0, -(SP)
                mov     R1, -(SP)
                mov     R2, -(SP)
                bis     #4000, R0
                mov     PC, R1
2$:             tst     (R1)
                beq     4$
                cmp     (R1)+, R0
                bne     2$
                jmp     (R1)
; ───────────────────────────────────────────────────────────────────────────
                .word 4012              ; код 12
3$:             mov     #33, R0         ; обрабатываем так - стрелка вниз
4$:             call    @100016         ; стандартный EMT 16
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4037              ; код 37
                br      3$              ; обрабатываем так же, как и 12
; ───────────────────────────────────────────────────────────────────────────
                .word 4015              ; код 15
                clr     CRDX80          ; Своя координата курсора Х
                tst     word_1010
                bne     3$
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4014              ; код 14 - сбр
                clr     CRDX80          ; Своя координата курсора Х
                br      4$
; ───────────────────────────────────────────────────────────────────────────
                .word 4010              ; код 10 - стрелка влево
                tst     CRDX80          ; Своя координата курсора Х
                beq     6$
                dec     CRDX80          ; Своя координата курсора Х
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4011              ; код 11 - таб
                emt     26
                mov     R1, R0
                com     R0
                bic     #177770, R0
                inc     R0
                add     R0, R1
                emt     24
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4030              ; код 30 - забой
                tst     W80SLN          ; флаг, 80 символов в строке
                beq     4$
                dec     CRDX80          ; Своя координата курсора Х
                mov     #40, R0
                call    sub_5404
                dec     CRDX80          ; Своя координата курсора Х
                br      6$
; ───────────────────────────────────────────────────────────────────────────
                .word 4031              ; код 31 - стрелка вправо
                cmp     CRDX80, #79.    ; Своя координата курсора Х
                blo     5$
                clr     CRDX80          ; Своя координата курсора Х
                br      3$

5$:             inc     CRDX80          ; Своя координата курсора Х
6$:             mov     (SP)+, R2
                mov     (SP)+, R1
                mov     (SP)+, R0
loc_7376:       mov     (SP)+, R5
                rti
; ───────────────────────────────────────────────────────────────────────────
                .word 0                 ; всё, конец цепочки

; ───────────────────────────────────────────────────────────────────────────
; Перехватчик ЕМТ 24 - установка координат курсора
E24H$:          tst     (PC)+
W80SLN:         .word 177777            ; флаг, 80 символов в строке
                beq     loc_7076
                mov     R1, CRDX80      ; Своя координата курсора Х
                clr     R1
                call    @100024         ;стандартный EMT 24
                br      loc_7376

; ───────────────────────────────────────────────────────────────────────────
; Перехватчик ЕМТ 26 - получение координат курсора
E26H$:          call    @100026         ;стандартный EMT 26
                tst     W80SLN          ; флаг, 80 символов в строке
                beq     loc_7376
                mov     CRDX80, R1      ; Своя координата курсора Х
                br      loc_7376

; ───────────────────────────────────────────────────────────────────────────
; Команда IOT. Вывод символа
; Входной параметр в R0 - код символа
VEC20:          jsr     R5, PUSHAR
                bic     #177400, R0
                aslb    R0
                bcc     1$
                add     #300, R0
1$:             mov     R0, R2
                asl     R0
                asl     R0
                add     R2, R0
                add     #111576, R0     ; Получаем адрес символа в шрифте
                mov     #5, R2
                mov     #200, R4
                mov     #NOMSIM, R1     ; Системные ячейки драйвера экрана
                inc     (R1)+           ; Увеличиваем номер символа на экране
                mov     (R1), R3        ; Абсолютный адрес курсора в ОЗУ экрана
                inc     (R1)
                mov     word_10174, R1  ; какая-то маска
                tstb    PRPODC          ; Подчёркивание включено?
                bne     2$              ; да
                asl     R1              ; нет - скорректируем маску
2$:             mov     (R0), R5        ; берём сразу 2 байта из матрицы символа
                tstb    57
                bne     3$
                tstb    @#PRPODC        ; что там с подчёркиванием?
                beq     4$              ; нету
3$:             asr     R5              ; а если есть - ужирним символ
                bis     (R0), R5
                bic     R1, R5          ; применим маску
                tstb    @#57
                beq     4$
                mov     R5, -(SP)       ; ещё сильнее ужирним
                asr     R5
                bis     (SP)+, R5
4$:             tstb    @#PRINWS        ; Инверсия символа включена?
                beq     5$      ; нет
                com     R5              ; да - проинвертируем
5$:             tst     (R0)+           ; подвинем указатель к следующим байтам из матрицы символа
                movb    R5, (R3)        ; рисуем первый байт на экране
                swab    R5
                movb    R5, 100(R3)     ; и второй (тут смелое допущение, что R3 никогда не будет 777хх)
                add     R4, R3          ; прибавляем смещение
                bpl     6$              ; нужно ли коректировать адрес?
                sub     #40000, R3      ; если нужно - скорректируем
6$:             sob     R2, 2$
                jsr     R5, POPAR
                rti

; ───────────────────────────────────────────────────────────────────────────
VEC274:         com     177660          ;запретим прерывания от клавиатуры
                mov     R0, -(SP)
                call    GETCHR
                bis     #600, R0
                br      8$

; ───────────────────────────────────────────────────────────────────────────
VEC60:          com     177660          ;запретим прерывания от клавиатуры
                mov     R0, -(SP)
                call    GETCHR
                bis     #400, R0        ;в ст. байте будет флаг нового кода
                tst     (PC)+
word_7702:      .word 0
                bne     1$
                cmpb    #23, R0
                bne     2$
                com     word_7702
                br      6$

1$:             bicb    #340, R0
                br      8$

2$:             cmpb    #3, R0  ;если КТ
                bne     3$
                clrb    R0
                bisb    #33, R0 ;заменим его на префикс Esc
                br      8$

3$:             cmpb    #33, R0 ;если 33
                bne     4$
                clrb    R0
                bisb    #37, R0 ;подменим его на 37
                br      8$

4$:             cmpb    #16, R0 ; если РУС
                bne     5$
                movb    #200, PRRUS     ;зададим режи Рус
                br      6$

5$:             cmpb    #17, R0 ;если ЛАТ
                bne     7$
                clrb    PRRUS   ;зададим режим Лат
6$:             clr     R0      ;а код обнулим
7$:             cmpb    #100, R0
                bhi     8$
                bisb    PRRUS, R0       ;для букв применим рус/лат
8$:             mov     R0, BUFKL
                mov     (SP)+, R0
                clr     177660
                rti

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

GETCHR:         mov     R2, -(SP)
                mov     R3, -(SP)
                mov     #2, R2
                call    102056          ;получение скан кода и звук нажатия
                mov     (SP)+, R3
                mov     (SP)+, R2
                return
; End of function GETCHR

; ───────────────────────────────────────────────────────────────────────────
VEC34:          mov     R5, -(SP)
                mov     2(SP), R5
                mov     -(R5), R5       ; Получим код команды TRAP
                movb    R5, R5          ; код трапа, со знаком
                bmi     6$              ; если >= 200, то игнорируем
                mov     R0, -(SP)
                mov     R1, -(SP)
                mov     #TRPRES, R1     ; массив данных для соответствующих трапов.
                                        ; формат:
                                        ; .word адрес вывода на экран
                                        ; .asciz текст
                                        ; .even
1$:             dec     R5              ; уменьшим номер трапа
                bmi     4$              ; всё, конец, некуда уменьшать
2$:             tstb    (R1)+           ; сперва пропустим ненулевые байты
                bne     2$
                dec     R1
3$:             tstb    (R1)+           ; потом - нулевые
                beq     3$
                dec     R1
                br      1$              ; и повторим

4$:             mov     (R1)+, R0
                add     @#BAZVP, R0     ; прибавим адрес начала информационной части экрана
                bpl     5$
                sub     #40000, R0      ; если надо - скорректируем
5$:             mov     R0, AS          ; получим адрес курсора в ОЗУ, и поместим его на место
                emt     20
                mov     (SP)+, R1
                mov     (SP)+, R0
6$:             mov     (SP)+, R5
                rti
; ───────────────────────────────────────────────────────────────────────────
word_10166:     .word 0
word_10170:     .word 0
word_10172:     .word 0
word_10174:     .word 0
                .byte 0
                .byte 0
TX_LogBuffPtr:  .word 40000     ;указатель в буфере лога передатчика
word_10202:     .word 0

TRPRES:         .word 42465             ; trap 0
                .asciz "OFF"
                .even
                .word 42465             ; trap 1
                .asciz "ON "
                .even
                .word 43665             ; trap 2
                .asciz "OFF"
                .even
                .word 43665             ; trap 3
                .asciz "ON "
                .even
                .word 52050             ; trap 4
                .asciz ""
                .even
                .word 53250             ; trap 5
                .asciz ""
                .even
                .word 54447             ; trap 6
                .asciz ""
                .even
                .word 55650             ; trap 7
                .asciz ""
                .even
                .word 57050             ; trap 10
                .asciz ""
                .even
                .word 60247             ; trap 11
                .asciz ""
                .even
                .word 61447             ; trap 12
                .asciz ""
                .even
                .word 62650             ; trap 13
                .asciz ""
                .even
                .word 64050             ; trap 14
                .asciz ""
                .even
                .word 62650             ; trap 15
                .asciz "Receive's aborted"
                .even
                .word 64050             ; trap 16
                .byte 277,277,277,277,277,277,277,277,277,277,0
                .even
                .word 62650             ; trap 17
                .asciz "Bad CRC-16 !"
                .even
                .word 62650             ; trap 20
                .asciz "Disk full !"<5>
                .even
                .word 62650             ; trap 21
                .asciz "DIR full !"<7>
                .even
                .word 62650             ; trap 22
                .asciz "Bad HDR !"<10>
                .even
                .word 62650             ; trap 23
                .asciz "Timeout HDR !"<4>
                .even
                .word 62650             ; trap 24
                .asciz "Bad leght frame ! "
                .even
                .word 62650             ; trap 25
                .asciz "ERROR Timeout !"<3>
                .even
                .word 62650             ; trap 26
                .asciz "ERROR Inicialize !"
                .even
                .word 62650             ; trap 27
                .asciz "Inicialize OK !"
                .even
                .word 53250             ; trap 30
                .byte 10,10,0
                .even
                .word 55650             ; trap 31
                .byte 10,10,0
                .even
                .word 57050             ; trap 32
                .byte 10,10,0
                .even
                .word 62650             ; trap 33
                .byte 10,10,3,0
                .even
                .word 62650             ; trap 34
                .asciz "Waiting ZFIN !!!"
                .even
                .word 45067             ; trap 35
                .asciz "ON "
                .even
                .word 45067             ; trap 36
                .asciz "OFF"
                .even
                .word 50670             ; trap 37
                .asciz "ON "
                .even
                .word 50670             ; trap 40
                .asciz "OFF"
                .even
                .word 36201             ; trap 41
                .asciz <234>"Term95 x0.07 (c) ED inc. 08-Jun-95"<234>
                .even
                .word 36266             ; trap 42
                .asciz <234>"СТОП-menu"<234>
                .even
                .word 60250             ; trap 43
                .byte 10,10,0
                .even
                .word 61450             ; trap 44
                .byte 10,10,0
                .even
                .word 62650             ; trap 45
                .asciz "Waiting header !"
                .even
                .word 62650             ; trap 46
                .asciz "ERROR synchronize !"
                .even
                .word 62650             ; trap 47
                .asciz "Init receiver  !"
                .even
                .word 62650             ; trap 50
                .asciz "Send's aborted !"
                .even
                .word 62650             ; trap 51
                .asciz "Send's resumed !"
                .even
                .word 62650             ; trap 52
                .asciz "Repeat sending !"
                .even
                .word 50650             ; trap 53
                .asciz "Receiving"
                .even
                .word 50650             ; trap 54
                .asciz "Sending   "
                .even
                .word 52072             ; trap 55
                .asciz "ON "
                .even
                .word 52072             ; trap 56
                .asciz "OFF"
                .even
                .word 53272             ; trap 57
                .asciz "YES"
                .even
                .word 53272             ; trap 60
                .asciz "NO "
                .even
MainMenu:       .ascii <237>"T"<237>"erminal"<12>
                .ascii <237>"E"<237>"cho"<12>
                .ascii <237>"A"<237>"NSI"<12>
                .ascii "autoD"<237>"L"<12>
                .ascii "U"<237>"pload"<12>
                .ascii <237>"D"<237>"ownload"<12>
                .ascii <237>"C"<237>"opyscr"<12>
                .ascii <237>"X"<237>"on/Xoff"<12>
                .ascii <237>"N"<237>"ew IRPS"<12>
                .ascii <237>"Q"<237>"uit to DOS"
                .even

DownloadWndText:.ascii "         File "<12>
                .ascii "Protocol    : Zmodem"<12>
                .ascii "FileName    :"<12>
                .ascii "Elapsed Time: 00:00:00"<12>
                .ascii "FileSize    :"<7><12>
                .ascii "Byte count  :"<7><12>
                .ascii "Average CPS :"<7><12>
                .ascii "Corrections :"<7><12>
                .ascii "Last message:"<7><12>
                .ascii "Progress    : "
                .byte 277,277,277,277,277,277,277,277,277,277,0
                .even

                ; Матрица символов с кодами 200..237
byte_11704:     .byte 0,0,10,0,76,0,10,0,0,0
                .byte 24,24,24,367,0,377,0,0,0,0,0,0
                .byte 44,146,377,146,44,0,0,0,0,0,0,37
                .byte 20,27,24,24,24,24,24,24,24,27,20,27
                .byte 24,24,24,24,24,24,24,364,4,364,24,24
                .byte 24,24,24,24,24,364,4,374,0,0,0,0
                .byte 0,0,0,0,37,24,24,24,24,24,0,0
                .byte 0,0,0,377,377,377,377,377,360,360,360,360
                .byte 360,360,360,360,360,360,0,0,0,374,4,364
                .byte 24,24,24,24,0,0,0,377,0,367,24,24
                .byte 24,24,0,0,0,370,10,370,10,10,10,10
                .byte 377,377,377,377,377,377,377,377,377,377,0,76
                .byte 101,125,101,135,111,101,76,0,0,0,46,31
                .byte 0,46,31,0,0,0,24,24,24,24,27,24
                .byte 24,24,24,24,104,21,104,21,104,21,104,21
                .byte 104,21,24,24,24,367,0,367,24,24,24,24
                .byte 14,22,2,14,22,22,14,20,22,14,17,17
                .byte 17,17,17,17,17,17,17,17,0,0,0,0
                .byte 374,24,24,24,24,24,10,10,10,370,10,370
                .byte 0,0,0,0,0,0,0,34,76,76,76,34
                .byte 0,0,377,377,377,377,377,0,0,0,0,0
                .byte 24,24,24,27,20,37,0,0,0,0,10,10
                .byte 10,17,10,17,0,0,0,0,0,0,0,17
                .byte 10,17,10,10,10,10,0,0,0,34,42,42
                .byte 42,34,0,0,24,24,24,24,364,24,24,24
                .byte 24,24,252,125,252,125,252,125,252,125,252,125
                .byte 314,63,314,63,314,63,314,63,314,63,314,63

                .word   0 ;кажется, мусор
                .word   10.
                .word   100.
                .word   1000.

; таблица перекодировки
byte_12416:     .byte 012,216,000,242,270,264,251,007,010,011,012,000,014,015,000,000
                .byte 000,000,202,000,240,223,000,000,263,255,261,276,040,010,032,037
                .byte 040,041,042,043,044,045,046,047,050,051,052,053,054,055,056,057
                .byte 060,061,062,063,064,065,066,067,070,071,072,073,074,075,076,077
                .byte 100,101,102,103,104,105,106,107,110,111,112,113,114,115,116,117
                .byte 120,121,122,123,124,125,126,127,130,131,132,133,134,135,136,137
                .byte 140,141,142,143,144,145,146,147,150,151,152,153,154,155,156,157
                .byte 160,161,162,163,164,165,166,167,170,171,172,173,174,175,176,030
                .byte 341,342,367,347,344,345,366,372,351,352,353,354,355,356,357,360
                .byte 362,363,364,365,346,350,343,376,373,375,377,371,370,374,340,361
                .byte 301,302,327,307,304,305,326,332,311,312,313,314,315,316,317,320
                .byte 277,236,221,267,260,244,220,207,233,204,257,203,231,271,232,243
                .byte 246,241,253,245,265,256,275,235,206,212,201,213,205,247,222,274
                .byte 254,250,273,246,226,214,225,266,272,271,252,215,210,224,211,230
                .byte 322,323,324,325,306,310,303,336,333,335,337,331,330,334,300,321
                .byte 075,053,076,074,267,267,200,217,234,227,227,122,116,044,177,040

; таблица перекодировки
byte_13016:     .byte 000,001,002,003,004,005,006,007,010,011,015,013,014,012,016,017
                .byte 020,021,022,023,024,025,026,027,010,034,036,033,034,035,036,037
                .byte 040,041,042,043,044,045,046,047,050,051,052,053,054,055,056,057
                .byte 060,061,062,063,064,065,066,067,070,071,072,073,074,075,076,077
                .byte 100,101,102,103,104,105,106,107,110,111,112,113,114,115,116,117
                .byte 120,121,122,123,124,125,126,127,130,131,132,133,134,135,136,137
                .byte 140,141,142,143,144,145,146,147,150,151,152,153,154,155,156,157
                .byte 160,161,162,163,164,165,166,167,170,171,172,173,174,175,176,010
                .byte 366,312,334,273,271,307,310,371,367,336,311,313,324,333,001,370
                .byte 266,262,316,025,335,326,276,267,337,274,270,325,022,314,261,260
                .byte 024,301,003,277,265,303,300,315,321,006,332,302,320,031,305,272
                .byte 264,033,316,030,005,304,327,263,004,331,330,322,317,306,032,261
                .byte 356,240,241,346,244,245,344,243,345,250,251,252,253,254,255,256
                .byte 257,357,160,341,342,343,246,242,354,353,247,350,355,351,347,352
                .byte 236,200,201,226,204,205,224,203,225,210,211,212,213,214,110,216
                .byte 217,237,220,103,222,223,206,202,234,233,207,230,235,231,227,232
                .byte 0
                .byte 0
;какая-то таблица, может для подсчёта CRC
word_13420:     .word 0,10041,20102,30143
                .word 40204,50245,60306,70347
                .word 100410,110451,120512,130553
                .word 140614,150655,160716,170757
                .word 11061,1020,31163,21122
                .word 51265,41224,71367,61326
                .word 111471,101430,131573,121532
                .word 151675,141634,171777,161736
                .word 22142,32103,2040,12001
                .word 62346,72307,42244,52205
                .word 122552,132513,102450,112411
                .word 162756,172717,142654,152615
                .word 33123,23162,13021,3060
                .word 73327,63366,53225,43264
                .word 133533,123572,113431,103470
                .word 173737,163776,153635,143674
                .word 44304,54345,64206,74247
                .word 4100,14141,24002,34043
                .word 144714,154755,164616,174657
                .word 104510,114551,124412,134453
                .word 55365,45324,75267,65226
                .word 15161,5120,35063,25022
                .word 155775,145734,175677,165636
                .word 115571,105530,135473,125432
                .word 66246,76207,46344,56305
                .word 26042,36003,6140,16101
                .word 166656,176617,146754,156715
                .word 126452,136413,106550,116511
                .word 77227,67266,57325,47364
                .word 37023,27062,17121,7160
                .word 177637,167676,157735,147774
                .word 137433,127472,117531,107570
                .word 110610,100651,130712,120753
                .word 150414,140455,170516,160557
                .word 10200,241,30302,20343
                .word 50004,40045,70106,60147
                .word 101671,111630,121773,131732
                .word 141475,151434,161577,171536
                .word 1261,11220,21363,31322
                .word 41065,51024,61167,71126
                .word 132752,122713,112650,102611
                .word 172556,162517,152454,142415
                .word 32342,22303,12240,2201
                .word 72146,62107,52044,42005
                .word 123733,133772,103631,113670
                .word 163537,173576,143435,153474
                .word 23323,33362,3221,13260
                .word 63127,73166,43025,53064
                .word 154514,144555,174416,164457
                .word 114710,104751,134612,124653
                .word 54104,44145,74006,64047
                .word 14300,4341,34202,24243
                .word 145575,155534,165477,175436
                .word 105771,115730,125673,135632
                .word 45165,55124,65067,75026
                .word 5361,15320,25263,35222
                .word 176456,166417,156554,146515
                .word 136652,126613,116750,106711
                .word 76046,66007,56144,46105
                .word 36242,26203,16340,6301
                .word 167437,177476,147535,157574
                .word 127633,137672,107731,117770
                .word 67027,77066,47125,57164
                .word 27223,37262,7321,17360

EscCodes:       .asciz "n!hlABCDmHfusJK"
                .even
EscCodeSubTbl:  .word sub_EscCode156    ; cmd n
                .word sub_EscCode041    ; cmd !
                .word sub_EscCode150    ; cmd h
                .word sub_EscCode154    ; cmd l
                .word sub_EscCode101    ; cmd A
                .word sub_EscCode102    ; cmd B
                .word sub_EscCode103    ; cmd C
                .word sub_EscCode104    ; cmd D
                .word sub_EscCode155    ; cmd m
                .word sub_EscCode110_146        ; cmd H,f
                .word sub_EscCode110_146        ; cmd H,f
                .word sub_EscCode165    ; cmd u
                .word sub_EscCode163    ; cmd s
                .word sub_EscCode112    ; cmd J
                .word sub_EscCode113    ; cmd K
                .word 0                 ;конец таблицы

                .byte    0 ;   100000 TSH кажется, мусор
                .byte  200 ; ─
                .byte  100 ; @ 020100 EFP
                .byte   40 ;
                .byte   21 ;   005021 AXQ
                .byte   12 ;
                .byte    4 ;   000004   D
                .byte    0 ;

byte_14510:     .byte 00,00,01,02,03,03,04,05,06,06     ; номер байта в строке для 80 симв. в строке
                .byte 07,10,11,11,12,13,14,14,15,16
                .byte 17,17,20,21,22,22,23,24,25,25
                .byte 26,27,30,30,31,32,33,33,34,35
                .byte 36,36,37,40,41,41,42,43,44,44
                .byte 45,46,47,47,50,51,52,52,53,54
                .byte 55,55,56,57,60,60,61,62,63,63
                .byte 64,65,66,66,67,70,71,71,72,73
                .byte 74,74,75,76

byte_14634:     .byte 7,1,3,5,7,1,3,5,7,1 ; адрес маски отсечения для 80 символов в строке
                .byte 3,5,7,1,3,5,7,1,3,5 ; а ещё это смещение, поэтому значения нечётные
                .byte 7,1,3,5,7,1,3,5,7,1
                .byte 3,5,7,1,3,5,7,1,3,5
                .byte 7,1,3,5,7,1,3,5,7,1
                .byte 3,5,7,1,3,5,7,1,3,5
                .byte 7,1,3,5,7,1,3,5,7,1
                .byte 3,5,7,1,3,5,7,1,3,5
                .byte 7,1,3,5

word_14760:     .word 7700              ; маска отсечения для 80 символов в строке
                .word 1760
                .word 374
                .word 77

; ───────────────────────────────────────────────────────────────────────────
CheckAutoDL:    tst     (PC)+
AutoDLCatchFlag:.word 0
                bne     3$
                cmpb    #'r, R0
                beq     1$
                return

1$:             mov     #byte_23443, R5
2$:             com     AutoDLCatchFlag
                br      4$

3$:             mov     word_15036, R5
                cmpb    R0, (R5)+
                bne     2$
                tstb    (R5)
                beq     DownloadFunc
4$:             mov     R5, (PC)+
word_15036:     .word 0
                return

; ───────────────────────────────────────────────────────────────────────────
DownloadFunc:   clr     AutoDLCatchFlag
                call    PrepareIO
                trap    53
                mov     #4, R3
1$:             mov     R3, -(SP)
                .word /S17176+167366
                mov     (SP)+, R3
                bcs     2$
                cmpb    #4, R0
                beq     3$
                cmpb    #10, R0
                beq     S15166

2$:             jsr     R1, sub_20310
                .byte 6,0,0,0,0
                .even
                call    sub_16760
                sob     R3, 1$
                br      4$

3$:             call    sub_15216
                bcc     S15166
4$:             trap    15

V04.3:          .word /SendSTRING+167366
                .byte 30,30,30,30,30,30,30,30,30,30,10,10,10,10,10,10,10,10,10,10,0
                .even

; ───────────────────────────────────────────────────────────────────────────
S15166:         mov     #VEC04, 4
                .word /CloseOpenWindow+167366
                .word /MKD$TXT+167366
                .byte 7,7,7,7,7,7,7,7,7,7,7,0
                .even
                .word /Process+167366

; ───────────────────────────────────────────────────────────────────────────
sub_15216:      call    sub_15426
                bcc     1$
                cmpb    #5, R0
                beq     3$

1$:             mtps    -(SP)   ;ошибка? должно быть mfps судя по логике проги
                jsr     R5, PUSHAR
                mov     #26000, 177716
                clr     R5
                com     R5
                call    sub_17056
                mov     #16000, 177716
                mov     DIR, R3
                emt     226             ; Поиск файла в каталоге
                                        ; Вход:  R3 - адрес буфера каталога
                                        ;        @#NAM - адрес блока параметров EMT36
                                        ; Выход: R3 - адрес записи о файле, или бит C если файл не найден
                mov     FileBlkLength, R0
                cmp     R0, 22(R3)      ; сравним длину в блоках
                bne     2$
                mov     FileLoadAddr, 24(R3) ;адрес
                mov     FileLength, R0
2$:             mov     R0, 26(R3)      ; длина
                emt     242             ; Запись каталога
                .word /DriveOff+167366
                jsr     R5, POPAR
                mtps    (SP)+
                bcs     6$
                cmpb    #13, R0
                beq     4$
                cmpb    #10, R0
                bne     5$
                call    sub_20610
                br      5$

3$:             jsr     R1, sub_20310
                .byte 5,0,0,0,0
                .even
4$:             call    S17176
                bcs     6$
                cmpb    #17, R0
                bne     7$
                clr     R0
5$:             tst     (PC)+
6$:             sec
                return

7$:             cmpb    #4, R0
                beq     sub_15216
                br      6$

; ───────────────────────────────────────────────────────────────────────────
sub_15426:      jsr     R5, PUSHAR
                mov     #IOBuffer, R4
                mov     #BPDMAG, R5
                clr     (R5)+   ; чистим блок параметров
                clr     (R5)+
                clr     (R5)+
                mov     #10, R0
                mov     R5, R1
1$:             clr     (R1)+
                sob     R0, 1$
                clr     word_16750
                call    sub_16744
                trap    30
                trap    5

2$:             movb    (R4)+, R0
                tstb    byte_17461
                bne     3$
                emt     264             ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
3$:             emt     16
                movb    R0, (R5)+
                bne     2$
                clr     R1
                clr     R3
                clr     R0
                trap    31
                trap    32
                trap    7

4$:             movb    (R4)+, R0
                beq     6$
                cmpb    #40, R0
                beq     6$
                iot
                mov     #11, R2 ; какие-то таинственные действия
                sub     #60, R0
                mov     R1, R5
5$:             add     R5, R1
                adc     R3
                sob     R2, 5$
                add     R0, R1
                adc     R3
                br      4$

6$:             call    sub_20676
                mov     #FileLoadAddr, R5
                clr     (R5)    ; и ещё какие-то таинственные действия
7$:             movb    (R4)+, R0
                beq     8$
                cmpb    #40, R0
                beq     8$
                sub     #60, R0
                rol     (R5)
                rol     (R5)
                rol     (R5)
                bisb    R0, (R5)
                br      7$

8$:             mov     R1, -(SP)
                emt     224             ; Чтение каталога в буфер (@#DIR)
                emt     226             ; Поиск файла в каталоге
                mov     (SP)+, R1
                bcs     9$              ; не нашли - переходим
                tst     24(R3)          ; проверим адрес файла
                bne     12$
                mov     22(R3), FileBlkLength_Fnd
                mov     #FileLength, R1
                mov     26(R3), (R1)
                sub     (R1), FileBlkLength_Fnd
                mov     (R1), FileBlkLength
                mov     20(R3), BklNum_Fnd
                add     (R1), BklNum_Fnd
                asl     (R1)
                swab    (R1)
                clr     2(R1)
                bisb    (R1), 2(R1)
                clrb    (R1)
                br      15$

9$:             mov     DIR, R3
                tst     R1
                bne     10$
                com     R1
                emt     320             ; Поиск свободного места по длине в блоках
                br      11$

10$:            mov     R1, -(SP)
                emt     320             ; Поиск свободного места по длине в блоках
                mov     (SP)+, R1
11$:            bcc     14$
                tst     R3
                beq     13$
                trap    20
12$:            mov     #5, (SP)
                br      16$

13$:            trap    21
                mov     #-4, (SP)
                br      16$

14$:            mov     R1, FileBlkLength_Fnd
                mov     DIR, R4
                mov     R0, BklNum_Fnd
                mov     #FileLength, R0
                clr     (R0)+
                clr     (R0)+
                clr     (R0)+
                emt     322             ; Создание записи о файле по длине в блоках
15$:            clr     word_23460
                call    sub_16676
                clr     (SP)
16$:            jsr     R5, POPAR
                cmp     #5, R0
                bne     17$
                sec
                return

17$:            mov     #12, R3
loc_16074:      jsr     R1, sub_20310
                .byte 11
byte_16101:     .byte 0,0,0,0
                .even

jmp_16106:      call    sub_17610
                bcs     26$
                cmpb    #12, R0
                beq     28$
                cmpb    #6, R0
                bne     18$
                trap    22
                br      27$

18$:            cmp     #-1, R0
                bne     19$
                trap    23
                br      27$

39$:            br      loc_16074

19$:            cmpb    #4, R0
                bne     20$
                jsr     R1, sub_20416
                .word IOBuffer
                .word 1000
                bcs     27$
                br      loc_16074

20$:            cmpb    #5, R0
                bne     22$

21$:            trap    15
                br      25$

22$:            cmpb    #13, R0
                beq     24$
                cmpb    #10, R0
                bne     27$
                mov     #4, R1
                mov     #byte_23375, R2
                mov     #byte_17167, R5
23$:            cmpb    (R2)+, (R5)+
                bne     39$
                sob     R1, 23$
24$:            tst     (PC)+
25$:            sec
                return

26$:            jsr     R1, sub_20310
                .byte 6,0,0,0,0
                .even

27$:            call    sub_16760
                sob     R3, 39$
                br      21$

28$:            mov     #4, R1
                mov     #byte_16101, R2
                mov     #byte_23375, R5
29$:            cmpb    (R2)+, (R5)+
                bne     30$
                sob     R1, 29$
                br      33$

30$:            trap    46
                br      32$

31$:            trap    24

32$:            jsr     R1, sub_23224
                .word byte_23403
                br      27$

33$:            jsr     R1, sub_20416
                .word IOBuffer
                .word 2000
                bcs     31$
                cmp     #-1, R0
                bne     34$
                trap    25
                br      27$

34$:            cmp     #553, R0
                beq     37$
                cmp     #552, R0
                beq     36$
                cmp     #551, R0
                beq     35$
                cmp     #550, R0
                bne     27$
                call    sub_16462
                bcs     25$
                br      38$

35$:            call    sub_16462
                bcs     25$
                br      33$

36$:            call    sub_16462
                bcs     25$
                call    sub_17162
                br      33$

37$:            call    sub_16462
                bcs     25$
                call    sub_17162
38$:            jmp     jmp_16106

; ───────────────────────────────────────────────────────────────────────────
sub_16462:      mov     #12, R3
                mov     word_23460, R1
                beq     9$
                tst     FileBlkLength_Fnd
                blos    8$
                jsr     R5, PUSHAR
                mov     #26000, 177716
                .word /DriveOff+167366
                br      2$

1$:             tstb    XonXofOption
                beq     2$
                .word /SendSTRING+167366
                .asciz <21>
                .even
2$:             mov     2(SP), R1
                mov     word_17156, R5
                cmp     #40000, R5
                bne     3$
                mov     BklNum_Fnd, word_17116
3$:             add     R1, R5
                cmp     R5, #100000
                bhi     5$
                sub     R1, R5
                mov     #IOBuffer, R4
4$:             movb    (R4)+, (R5)+
                sob     R1, 4$
                mov     R5, word_17156
                ccc
                br      7$

5$:             clr     R5
                tstb    XonXofOption
                beq     6$
                .word /SendSTRING+167366
                .asciz <23>
                .even
6$:             call    sub_17056
                bcc     1$
7$:             mov     #16000, 177716
                jsr     R5, POPAR
                bcc     10$
8$:             sec
9$:             return

10$:            .word /S20662+167366
                add     R1, BklNum_Fnd
                add     R1, FileBlkLength
                sub     R1, FileBlkLength_Fnd
                clr     R0
                call    sub_16766

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_16676:      mov     #FileLength, R1
                add     word_23460, (R1)
                adc     2(R1)
                trap    10
                clr     R0
                .word /S06310+167366
                mov     #byte_16101, R0
                mov     #byte_17167, R2
                mov     #4, R5
1$:             movb    (R1), (R2)+
                movb    (R1)+, (R0)+
                sob     R5, 1$
                trap    33
; End of function sub_16676


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_16744:      trap    12
                mov     (PC)+, R0
word_16750:     .word 0
                bne     4$
                trap    44
                return

; ───────────────────────────────────────────────────────────────────────────
sub_16760:      inc     word_16750
                br      sub_16744

; ───────────────────────────────────────────────────────────────────────────
sub_16766:      trap    43
                trap    11
                mov     word_6634, R1
                beq     5$
                tst     R0
                beq     1$
                mov     SendCounter, R5
                beq     5$
                clr     SendCounter
                br      2$

1$:             mov     ReceiveCounter, R5
                clr     ReceiveCounter
2$:             clr     word_6634
                clr     R0
3$:             sub     R1, R5
                bmi     4$
                inc     R0
                br      3$

4$:             mov     R4, -(SP)
                emt     260             ; Вывод десятичного числа
                mov     (SP)+, R4
5$:             return
; End of function sub_16744


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_17056:      mov     word_17156, R1
                sub     #40000, R1
                tst     R5
                bne     1$
                mov     R1, R0
                bic     #177000, R0
                sub     R0, R1
                mov     R0, -(SP)
                mov     R1, -(SP)

1$:             asr     R1
                adc     R1
                neg     R1
                mov     (PC)+, R0
word_17116:     .word 0
                mov     #40000, R2
                mov     R5, -(SP)
                mov     R2, -(SP)
                emt     222             ; Чтение/запись блока (160004 исп.буфер ДОС)
                mov     (SP)+, R2
                mov     (SP)+, R5
                bne     3$
                mov     (SP)+, R1
                mov     (SP)+, R0
                beq     3$
                bcs     3$
2$:             movb    (R1)+, (R2)+
                sob     R0, 2$
3$:             mov     R2, (PC)+
word_17156:     .word 40000
                return
; End of function sub_17056


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_17162:      jsr     R1, sub_20310
                .byte 3
byte_17167:     .byte 0,0,0,0
                .even
                return

; ───────────────────────────────────────────────────────────────────────────
S17176:         clrb    byte_17461
                mov     #4, R0
                movb    R0, byte_17250
                tstb    XonXofOption
                bne     1$
                tstb    NewIRPSOption
                beq     2$
1$:             mov     #6, R0
                clrb    byte_17250
2$:             movb    R0, byte_17252
                jsr     R1, sub_20310
                .byte 1
                .byte 0
byte_17250:     .byte 4
                .byte 0
byte_17252:     .byte 4
                .even
                mov     #14, R3

loc_17260:      trap    45
                call    sub_17610
                bcs     8$
                trap    33
                tstb    R0
                beq     S17176
                cmpb    #4, R0
                bne     11$
                trap    43
                jsr     R1, sub_20416
                .word IOBuffer
                .word 1000
                bcs     loc_17342
                cmp     #553, R0
                bne     loc_17342
                mov     #4, R0

loc_17332:      trap    33
                tst     (PC)+
loc_17336:      sec
                return

loc_17342:      trap    26

8$:             cmp     #-1, R0
                beq     loc_17332

loc_17352:      jsr     R1, sub_20310
                .byte 6,0,0,0,0
                .even
                br      loc_17366

loc_17366:      call    sub_16760
                sob     R3, loc_17260
                br      loc_17336

11$:            cmpb    #2, R0
                bne     14$
                jsr     R1, sub_20416
                .word byte_23403
                .word 40
                bcs     loc_17352
                cmp     #553, R0
                bne     loc_17342
                mov     #byte_22565, R1
                mov     #byte_23375, R2
                mov     #3, R0
12$:            cmpb    (R1)+, (R2)+
                bne     13$
                sob     R0, 12$
                comb    byte_17461
13$:            jsr     R1, sub_20310
                .byte 3
                .byte 1
                .byte 0
byte_17461:     .byte 377
                .byte 0
                .even
                trap    27
                br      loc_17260

14$:            cmpb    #21, R0
                bne     15$
                jsr     R1, sub_20310
                .byte 3,0,0,0,0
                .even
                br      loc_17260

15$:            cmpb    #22, R0
                bne     16$
                mov     #12, R3
                jsr     R1, sub_20416
                .word IOBuffer
                .word 1000
                cmp     #553, R0
                bne     loc_17342
                jsr     R1, sub_20310
                .byte 17,0,0,0,0
                .even
                call    sub_17610
                br      17$

16$:            cmpb    #17, R0
                beq     loc_17342
                cmpb    #10, R0
                bne     loc_17366

17$:            call    sub_20610
                mov     #17, R0
                br      loc_17332

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_17610:      mov     R3, -(SP)
                mov     #2400., R3
1$:             .word /S04252+167366
                bcs     12$
                cmpb    #'*, R0
                beq     3$
                cmpb    #152, R0 ; 'j'
                beq     3$
2$:             sob     R3, 1$
                br      11$

3$:             .word /S04252+167366
                bcs     12$
                cmpb    #'*, R0
                beq     3$
                cmpb    #30, R0
                bne     2$
                .word /S04252+167366
                bcs     12$
                clrb    byte_1020
                cmpb    #'A, R0
                beq     4$
                cmpb    #'B, R0
                bne     12$
                comb    byte_1020
4$:             mov     #byte_23374, R5
                mov     R5, R1
                mov     #7, R0
                mov     R0, R2
5$:             clrb    (R1)+
                sob     R0, 5$

6$:             mov     #2, R1
                tstb    byte_1020
                bne     7$
                dec     R1
7$:             call    sub_20066
                call    sub_23154
                tst     R1
                bne     7$
                sob     R2, 6$
                mov     #byte_23374, R1
                mov     #5, R5
                call    S04164
                mov     #byte_23403, R5
                mov     #word_4250, R1
                cmpb    (R1)+, -(R5)
                bne     8$
                cmpb    (R1)+, -(R5)
                beq     9$
8$:             trap    17
                br      12$

9$:             tstb    byte_1020
                beq     10$
                .word /S04330+167366
                cmpb    #15, R0
                bne     12$
                .word /S04330+167366
                .word /S04336+167366
                .word 1
                bcs     10$
10$:            movb    byte_23374, R0
11$:            tst     (PC)+
12$:            sec
                mov     (SP)+, R3
                return
; End of function sub_17610

; ───────────────────────────────────────────────────────────────────────────
sub_20066:      .word /S04330+167366
                bcs     6$
                cmpb    #21, R0
                beq     sub_20066
                cmpb    #23, R0
                beq     sub_20066
                cmpb    #30, R0
                bne     5$
                .word /S04330+167366
                bcs     6$
                cmpb    #30, R0
                beq     1$
                cmpb    #'h, R0
                bhi     2$
                cmpb    #'l, R0
                blos    2$
1$:             bis     #400, R0
                br      5$

2$:             cmpb    #'l, R0
                bne     3$
                mov     #177, R0 ; ''
                br      5$

3$:             cmpb    #'m, R0
                bne     4$
                mov     #377, R0
                br      5$

4$:             bitb    #100, R0
                beq     6$
                bitb    #40, R0
                bne     6$
                bicb    #100, R0
5$:             tst     (PC)+
6$:             sec
                return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;вывод байта в 16-ричной форме
;вход: R0 - байт
sub_20226:      mov     R1, -(SP)
                mov     R0, -(SP)
                mov     #2, R1
1$:             clr     R0
                rolb    (SP)
                rolb    R0
                rolb    (SP)
                rolb    R0
                rolb    (SP)
                rolb    R0
                rolb    (SP)
                rolb    R0
                add     #'0, R0
                cmpb    #'9, R0
                bhis    2$
                add     #47, R0
2$:             .word /SendCHAR+167366
                sob     R1, 1$
                mov     (SP)+, R0
                mov     (SP)+, R1
                return
; End of function sub_20226

; ───────────────────────────────────────────────────────────────────────────
sub_20310:      .word /SendSTRING+167366
                .asciz "**"<30>"B"
                .even
                mov     #5, R5
                .word /S04164+167366
1$:             movb    (R1)+, R0
                call    sub_20226
                sob     R5, 1$
                mov     word_4250, R0
                mov     R0, -(SP)
                swab    R0
                call    sub_20226
                mov     (SP)+, R0
                call    sub_20226
                .word /SendSTRING+167366
                .asciz <15><12>
                .even
                movb    -5(R1), R0
                cmpb    #10, R0
                beq     2$
                cmpb    #3, R0
                beq     2$
                .word /SendSTRING+167366
                .asciz <21>
                .even
2$:             inc     R1
                rts     R1

; ───────────────────────────────────────────────────────────────────────────
sub_20416:      mov     R3, -(SP)
                mov     R2, -(SP)
                mov     (R1)+, R2
                mov     (R1)+, R3
                mov     R1, -(SP)
                inc     R3
                clr     word_4250
                clr     word_23460

1$:             call    sub_20066
                bcs     7$
                bit     #177400, R0
                beq     8$
2$:             cmp     #550, R0
                bhi     5$
                cmp     #554, R0
                blos    5$
                mov     R0, R5
                mov     #2, R1
                movb    R0, R0
                clr     R2
                .word /S04134+167366
3$:             call    sub_20066
                bit     #177400, R0
                bne     2$
                swab    R2
                bisb    R0, R2
                sob     R1, 3$
                cmp     word_4250, R2
                beq     4$
                trap    17
                br      7$

4$:             mov     R5, R0
                br      6$

5$:             cmp     #430, R0
                bne     7$
                mov     #20, R0
6$:             tst     (PC)+
7$:             sec
                mov     (SP)+, R1
                mov     (SP)+, R2
                mov     (SP)+, R3
                rts     R1

8$:             movb    R0, (R2)+
                call    S04134
                inc     word_23460
                sob     R3, 1$
                br      7$

; ───────────────────────────────────────────────────────────────────────────
sub_20610:      mov     #4, R3
                jsr     R1, sub_20310
                .byte 10,0,0,0,0
                .even
                trap    34
1$:             .word /S04336+167366
                .word 1
                bcs     3$
                cmpb    #'O, R0
                bne     2$
                .word /S04336+167366
                .word 1
                return

2$:             tstb    R0
                bmi     3$
                sob     R3, 1$
3$:             return

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;преобразование длины в байтах в дину в блоках
S20662:         add     #777, R1
sub_20666:      clrb    R1
                swab    R1
                asr     R1
                return
; End of function sub_20666


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_20676:      add     #777, R1
                adc     R3
sub_20704:      call    sub_20666
                bit     #177400, R3
                beq     3$
2$:             dec     R3
                bmi     4$
                add     #200, R1
                br      2$

3$:             swab    R3
                asr     R3
                add     R3, R1
4$:             return
; End of function sub_20676

; ───────────────────────────────────────────────────────────────────────────

UploadFunc:         call    PrepareIO
                trap    54
jmp_20746:      mov     DIR, R3
                mov     30(R3), R1      ;? какие-то недокументированные тонкости?
                add     #450, R3
1$:             add     #30, R3
                cmpb    #377, (R3)
                beq     1$
                tst     22(R3)
                bmi     3$
                sob     R1, 1$
                jsr     R1, sub_23074
                .byte 10,0,0,0,0
                .even
                trap    34
                call    sub_17610
                bcs     2$
                .word /SendSTRING+167366
                .asciz "OO"
                .even
2$:             .word /S15166+167366
3$:             mov     R3, -(SP)
                call    sub_22370
                mov     (SP)+, R3
                bcc     4$
                trap    50
                br      2$

4$:             mov     R3, word_22174
                clr     word_16750
                call    sub_16744
                trap    30
                trap    5
                tst     (R3)+
                mov     #16, R1
                add     R1, R3
                mov     R3, -(SP)

5$:             dec     R1
                bmi     2$
                cmpb    #40, -(R3) ; ' '
                bhis    5$
                sub     R1, R3
                inc     R1
                mov     #byte_23464, R5
6$:             movb    (R3)+, R0
                emt     262             ; Замена управляющих кодов в R0 на пробелы
                iot
                tstb    byte_17461
                bne     7$
                emt     264             ; Привести R0 к ЛАТ,ЗАГЛ регистру(корректно)
                bisb    #40, R0
7$:             movb    R0, (R5)+
                sob     R1, 6$
                clrb    (R5)+
                mov     (SP)+, R3
                mov     #FileBlkLength, R1
                clr     -(R1)
                clr     -(R1)
                mov     (R3)+, BklNum_Fnd
                mov     (R3)+, (R1)
                bic     #100000, (R1)
                mov     (R1), FileBlkLength
                dec     FileBlkLength
                asl     (R1)
                swab    (R1)
                bisb    (R1), 2(R1)
                clrb    (R1)
                mov     2(R3), R0
                bic     #177000, R0
                beq     8$
                sub     #1000, (R1)
                sbc     2(R1)
                add     R0, (R1)
                adc     2(R1)
                br      9$

8$:             add     #1000, R0
9$:             mov     R0, word_23460
                trap    31
                trap    32
                trap    7
                mov     R5, R0
                .word /S06310+167366
10$:            tstb    (R5)+
                bne     10$
                movb    #40, -(R5)
                inc     R5
                mov     (R3), R1
                mov     #6, R2
                clr     R0
                br      12$

11$:            clr     R0
                rol     R1
                rol     R0
                rol     R1
                rol     R0
12$:            rol     R1
                rol     R0
                add     #'0, R0
                movb    R0, (R5)+
                sob     R2, 11$
                clrb    (R5)+
                sub     #byte_23464, R5
                mov     R5, word_21414
                br      loc_21374

loc_21370:      call    sub_16760
loc_21374:      jsr     R1, sub_23074
                .byte 4,0,0,0,0
                .even
                jsr     R2, sub_23012
                .word byte_23464
word_21414:     .word 0
                .word 153

15$:            call    sub_17610
                bcs     loc_21370
                cmpb    #1, R0
                bne     16$
                .word /S04336+167366
                .word 5
                bcs     loc_21370
                cmpb    #'*, R0
                beq     15$
                br      loc_21370

16$:            cmpb    #20, R0
                bne     18$
loc_21460:      jmp     jmp_20746

18$:            cmpb    #10, R0
                beq     loc_21460
                cmpb    #7, R0
                beq     loc_21460
                cmpb    #5, R0
                bne     19$
                jmp     jmp_22172

19$:            cmpb    #11, R0
                bne     loc_21374
                call    sub_22346
                mov     R5, -(SP)
20$:            movb    (R2), (R3)+
                movb    (R2)+, (R5)+
                sob     R1, 20$
                tst     -(R5)
                bne     21$
                tst     -(R5)
                beq     22$
21$:            trap    51
22$:            mov     (SP)+, R1
                trap    10
                clr     R0
                .word /S06310+167366
                clr     SendCounter
                clr     word_6634
                clr     word_21716
                br      25$

loc_21574:      call    sub_22210
                bcs     loc_21460
                cmpb    #11, R0
                beq     25$
                cmp     #-1, R0
                beq     25$
                cmpb    #3, R0
                beq     25$
                br      loc_21460

loc_21626:      call    sub_16760
25$:            .word /SendSTRING+167366
                .asciz <21>
                .even
                jsr     R1, sub_23074
                .byte 12
byte_21643:     .byte 0,0,0,0
                .even

loc_21650:      mov     #-1, R0
                call    sub_16766
                trap    10
                mov     #FileLength, R1
                clr     R0
                .word /S06310+167366
                mov     R1, R0
                mov     (R0)+, R1
                mov     (R0), R3
                call    sub_20704
                mov     R1, R0
                cmp     R0, FileBlkLength
                blo     27$
                com     (PC)+
word_21716:     .word 0
                mov     word_23460, R1
                br      28$

27$:            mov     #1000, R1
28$:            mov     R1, word_22022
                asr     R1
                adc     R1
                mov     #IOBuffer, R2
                add     BklNum_Fnd, R0
                mov     R4, -(SP)
                emt     222             ; Чтение/запись блока (160004 исп.буфер ДОС)
                mov     (SP)+, R4
                mov     #word_22024, R1
                mov     #'h, (R1)
                tst     word_21716
                bne     29$
                mov     #'k, (R1)
                tst     word_22522
                beq     29$
                mov     #'i, (R1)

29$:            jsr     R2, sub_23012
                .word IOBuffer
word_22022:     .word 1000
word_22024:     .word 153
                trap    33
                tst     word_21716
                bne     32$
30$:            cmp     R4, RX_BuffPtr
                beq     31$
                .word /S04330+167366
                cmpb    #'*, R0
                beq     loc_21574
                br      30$

31$:            tst     word_22522
                beq     loc_21574
                mov     #FileLength, R5
                add     #1000, (R5)+
                adc     (R5)
                br      loc_21650

32$:            call    sub_22346
                add     word_23460, (R5)
                adc     2(R5)
                mov     #byte_22143, R3
33$:            movb    (R5)+, (R3)+
                sob     R1, 33$
                trap    10
                mov     #FileLength, R1
                clr     R0
                .word /S06310+167366
                jsr     R1, sub_23074
                .byte 13
byte_22143:     .byte 0,0,0,0
                .even

34$:            call    sub_22210
                bcs     35$
                cmpb    #3, R0
                beq     34$
                cmpb    #11, R0
                beq     loc_21626
jmp_22172:      mov     (PC)+, R3
word_22174:     .word 120514
                bic     #100000, 22(R3)
35$:            jmp     jmp_20746

; ───────────────────────────────────────────────────────────────────────────
sub_22210:      mov     R3, -(SP)
                mov     #12, R3
1$:             call    sub_17610
                bcs     4$
                cmpb    #10, R0
                beq     3$
                cmpb    #7, R0
                beq     3$
                cmpb    #1, R0
                beq     2$
                cmpb    #11, R0
                beq     6$
                cmpb    #3, R0
                beq     6$
                cmpb    #5, R0
                bne     5$
2$:             tst     (PC)+
3$:             sec
                mov     (SP)+, R3
                return

4$:             jsr     R1, sub_23074
                .byte 6,0,0,0,0
                .even
5$:             sob     R3, 1$
                br      3$

6$:             call    sub_22346
7$:             cmpb    (R2)+, (R5)+
                bne     8$
                sob     R1, 7$
                trap    52
8$:             call    sub_22346
9$:             movb    (R2), (R3)+
                movb    (R2)+, (R5)+
                sob     R1, 9$
                br      2$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


sub_22346:      mov     #byte_23375, R2
                mov     #byte_21643, R3
                mov     #FileLength, R5
                mov     #4, R1
                return
; End of function sub_22346

; ───────────────────────────────────────────────────────────────────────────

sub_22370:      mov     #12, R3
                clrb    byte_17461
                .word /SendSTRING+167366
                .asciz "rz"<15>
                .even
1$:             jsr     R1, sub_20310
                .byte 0,0,0,0,0
                .even
                call    sub_17610
                bcs     2$
                cmpb    #16, R0
                bne     5$
                jsr     R1, sub_20310
                .byte 3,0,0,0,0
                .even
                br      4$

2$:             cmp     #-1, R0
                bne     3$
                trap    25
                br      4$

3$:             jsr     R1, sub_20310
                .byte 6,0,0,0,0
                .even
4$:             sob     R3, 1$
                br      13$

5$:             cmpb    #22, R0
                beq     4$
                tstb    R0
                beq     4$
                cmpb    #1, R0
                bne     2$
                clr     (PC)+
word_22522:     .word 0
                bitb    #2, byte_23400
                beq     7$
                tstb    XonXofOption
                bne     6$
                tstb    NewIRPSOption
                beq     7$
6$:             com     word_22522
7$:             mov     #12, R3
loc_22560:      jsr     R1, sub_23074
byte_22564:     .byte 2
byte_22565:     .byte 102
                .byte 113
                .byte 132
byte_22570:     .byte 0
                .even
                jsr     R2, sub_23012
                .word byte_22570
                .word 1
                .word 153
8$:             call    sub_17610
                bcc     10$
                jsr     R1, sub_23074
                .byte 6,0,0,0,0
                .even
9$:             sob     R3, loc_22560
                br      13$

10$:            cmpb    #3, R0
                beq     11$
                cmpb    #1, R0
                bne     9$
                .word /S04336+167366
                .word 5
                bcs     9$
                cmpb    #'*, R0
                beq     8$
                br      9$

11$:            cmpb    #377, byte_23377
                bne     12$
                comb    byte_17461
12$:            tst     (PC)+
13$:            sec
                return

; ───────────────────────────────────────────────────────────────────────────
sub_22704:      mov     R1, -(SP)
                mov     #100, R1
                cmpb    #15, R0
                beq     1$
                cmpb    #215, R0
                bne     2$
1$:             cmpb    word_23002, R1
                bne     4$
2$:             cmpb    #21, R0
                beq     3$
                cmpb    #221, R0
                beq     3$
                cmpb    #23, R0
                beq     3$
                cmpb    #223, R0
                beq     3$
                cmpb    #30, R0
                bne     4$
3$:             .word /SendSTRING+167366
                .asciz  <30>
                .even
                xor     R1, R0
4$:             movb    R0, (PC)+
word_23002:     .word 0
word_23004:     .word /SendCHAR+167366
                mov     (SP)+, R1
                return

; ───────────────────────────────────────────────────────────────────────────
sub_23012:      mov     R1, -(SP)
                mov     R5, -(SP)
                mov     (R2)+, R1
                mov     (R2)+, R5
                mov     (R2)+, R0
                movb    R0, byte_23053
                .word /S04164+167366
                .word /S04134+167366
1$:             dec     R5
                bmi     2$
                movb    (R1)+, R0
                call    sub_22704
                br      1$

2$:             .word /SendSTRING+167366
                .byte 30
byte_23053:     .byte 153
                .byte 0
                .even
                call    sub_23130
                .word /SendSTRING+167366
                .asciz  <21>
                .even
                mov     (SP)+, R5
                mov     (SP)+, R1
                rts     R2

; ───────────────────────────────────────────────────────────────────────────
sub_23074:      .word /SendSTRING+167366
                .asciz "*"<30>"A"
                .even
                mov     #5, R5
                .word /S04164+167366
1$:             movb    (R1)+, R0
                call    sub_22704
                sob     R5, 1$
                call    sub_23130
                inc     R1
                rts     R1

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_23130:      mov     word_4250, R0
                swab    R0
                call    sub_22704
                mov     word_4250, R0
                call    sub_22704
locret_23152:   return
; End of function sub_23130


; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;преобразовываем символ в 16ричном виде в число
;вход:  R0 - символ
;       R1 - длина числа в символах
;       R5 - буфер, где формируется число
sub_23154:      tstb    byte_1020
                beq     3$
                sub     #141, R0 ; 'a'
                bmi     1$
                add     #12, R0
                br      2$

1$:             add     #61, R0 ; '1'
2$:             ccc
                rolb    (R5)
                rolb    (R5)
                rolb    (R5)
                rolb    (R5)
3$:             bisb    R0, (R5)
                sob     R1, locret_23152
                inc     R5
                return
; End of function sub_23154


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_23224:      mov     (R1)+, R5
1$:             movb    (R5)+, R0
                bne     2$
                rts     R1

2$:             cmpb    #335, R0
                beq     1$
                cmpb    #336, R0
                beq     3$
                .word /SendCHAR+167366
                br      1$

3$:             cmpb    #31, word_6632
                bhis    3$
                mov     #1, word_6636
4$:             tst     word_6636
                bne     4$
                br      1$
; End of function sub_23224

; ───────────────────────────────────────────────────────────────────────────
PrepareIO:      mov     #V04.3, 4
                mov     #36000, 177716
                .word /ClrScr+167366
                mov     #16000, 177716
                .word /sub_EscCode163+167366    ; cmd s
                .word /S04564+167366
                .word 47430
                .word 44
                .word 170
                .word /S05220+167366
                .word DownloadWndText
                .word 1200
                emt     216             ; Инициализация драйвера дисковода
                movb    DEVTEK, 34(R3)  ; Номер текущего устройства
                movb    SUBTEK, SUBDIR  ; Номер подкаталога на тек. диске -> Подкаталог для CREATE, временн.
                mov     LD0, LD1        ; Смещение к логическому диску (в блоках), 0 - корень -> то же, но для текущей операции
                return
; ───────────────────────────────────────────────────────────────────────────
byte_23374:     .byte 0
byte_23375:     .byte 0
                .byte 0
byte_23377:     .byte 0
byte_23400:     .byte 0
                .byte 0
                .byte 0
byte_23403:     .blkb 40
byte_23443:     .byte 172
                .byte 15
                .byte 0
FileLength:     .word 0,0
FileBlkLength:  .word 0
FileBlkLength_Fnd: .word 0
BklNum_Fnd:     .word 0
word_23460:     .word 0
FileLoadAddr:   .word 1000
byte_23464:     .blkb 52
FreeSpace:
; ───────────────────────────────────────────────────────────────────────────
Prepare:        mov     #VERS, R0       ; Проверим версию МКДОС
                tst     (R0)
                bmi     10$             ; Если это вообще МКДОС, пойдём проверять дальше
loc_23546:      jsr     R1, sub_23670
; ───────────────────────────────────────────────────────────────────────────
                .word 137776
                .word 4
                .word 137
                .word 100000
                .word 100002
                .word 14747
                .ascii "Tы чего опупел что-ли ?"<12>
                .asciz "Гони минимум MKDOS V2.34, понял :-| !?!"<12>
                .even

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

sub_23670:      mov     (R1)+, R5       ; 137776 -> R5
                mov     R5, @(R1)+      ; 137776 -> @#4
                mov     (R1)+, @(R1)+   ; 137 -> @#100000
                mov     R5, @(R1)+      ; 137776 -> @#100002
                mov     (R1)+, (R5)     ; 14747 -> @#137776 - диверсия

3$:             movb    (R1)+, R0       ; Выводим текст
                beq     1$
2$:             emt     16
                mov     #30007, R0
                inc     PC              ; через раз
                br      2$

                sob     R0, .           ; делаем задержку
                br      3$

1$:             emt     6
                halt                    ; грохаем всё наглухо
; End of function sub_23670

; ───────────────────────────────────────────────────────────────────────────

10$:            cmpb    #234., (R0)     ; Проверяем версию МКДОС
                blos    loc_23546       ; если меньше 2.34, не работаем
                mov     30, V30BUF      ; сохраняем вектор EMT
                mov     #25, R1
                mov     #off_24112, R5  ; массив пар {значение, адрес}

4$:             mov     (R5)+, @(R5)+   ; инициализируем вектора и некоторые переменные
                sob     R1, 4$
                mov     424, R0         ; берём откуда-то палитру
                bic     #140000, R0     ; и таймер включаем
                mov     R0, 177662      ; применяем
                .word /ClrScr+167366    ; очистка экрана
                mov     #40000, R5      ; рисуем интерфейс
                mov     #7, R4
5$:             mov     #10421, R0
                mov     #40, R1
6$:             mov     R0, (R5)+
                sob     R1, 6$
                mov     #42104, R0
                mov     #40, R1
7$:             mov     R0, (R5)+
                sob     R1, 7$
                sob     R4, 5$
                mov     #42000, R5
                mov     #100, R1
8$:             com     -(R5)
                sob     R1, 8$
                trap    41              ; выводим заголовок проги
                trap    42              ; и подсказку - СТОП-menu
                .word /MKD$TXT+167366   ; выведем текст через мкдосную п/п TXT
                .asciz  <14>
                .even
                mov     RX_BuffPtr, R4
                tst     RX_DAT
                bis     #100, RX_CSR    ; разрешаем работу по прерыванию
                clr     word_6642       ; ненужная команда
                .word /DriveOff+167366  ; прекращаем дисководную активность
                .word /Process+167366   ; и начинаем работу

; массив пар {значение, адрес}
off_24112:      .word VEC04,    4
                .word 100,      6
                .word VEC20,    20
                .word 0,        22
                .word VEC30,    30
                .word 0,        32
                .word VEC34,    34
                .word 0,        36
                .word VEC60,    60
                .word 200,      62
                .word VEC274,   274
                .word 200,      276
                .word 377,      PRGAHK
                .word 0,        word_10172
                .word VEC10,    10
                .word 0,        12
                .word VEC100,   100
                .word 0,        102
                .word 1330,     177664
                .word VEC360,   360
                .word 340,      362


                .END
